#ifndef _AVI_EEPROM
#define _AVI_EEPROM

#include <stdint.h>
#include "eeprom.h"

#define MAGIC_INITIALIZED 0x3141592653589793ULL

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern float ee_omega_offset_x;
extern float ee_omega_offset_y;
extern float ee_omega_offset_z;

extern float omega_offset_x;
extern float omega_offset_y;
extern float omega_offset_z;

#define DEFAULT_OMEGA_OFFSET_X 0.00115f
#define DEFAULT_OMEGA_OFFSET_Y -0.0024f
#define DEFAULT_OMEGA_OFFSET_Z  0.0000f

//for magnetic fit
#define FITVARS 6 

extern void store_magnetic_calibration(uint8_t eeprom_ok,uint8_t reset_it, float *magnetic_offsets, float *magnetic_scales, float *magnetic_fit_matrix, float *magnetic_fit_rhs);
extern void read_magnetic_calibration(uint8_t eeprom_ok,float *magnetic_offsets, float *magnetic_scales, float *magnetic_fit_matrix, float *magnetic_fit_rhs);
extern void init_calibration(int eeprom_ok, int eeprom_reset, float *magnetic_offsets, float *magnetic_scales,float *magnetic_fit_matrix, float *magnetic_fit_rhs);
extern void print_calibration(const  float *magnetic_offsets, const float *magnetic_scales);
extern void init_omega_calibration(void);
extern void omega_calibration(float x, float y, float z);
extern void store_omega_calibration(uint8_t);



extern float p_pitot_calibration_offset;
extern float p_pitot2_calibration_offset;


#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
