#ifndef __CAN_H__
#define __CAN_H__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <setjmp.h>
#include <errno.h>
#include <math.h>
#include "usart123.h"
#include "delay.h"
#include "stm32f37x_gpio.h"
#include "stm32f37x_rcc.h"
#include "stm32f37x_pwr.h"
#include "stm32f37x_tim.h"
#include "stm32f37x_exti.h"
#include "stm32f37x_dma.h"
#include "stm32f37x_misc.h"
#include "stm32f37x_syscfg.h"
#include "stm32f37x_can.h"

#include "can_devind.h"

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif


extern uint8_t init_can(uint32_t baud,uint8_t autoretransmission);
extern uint8_t can_receive2(uint8_t *idtype,uint32_t *stdid, uint32_t *extid, uint8_t *rtr, uint8_t *data);
extern void can_transmit2(uint16_t id, uint8_t rtr, uint8_t len, uint8_t *data);
extern void can_transmit2_ext(uint16_t id, uint32_t extid, uint8_t rtr, uint8_t len, uint8_t *data);

extern uint8_t can_receive(CAN_MESSAGE *m);
extern uint8_t can_transmit(CAN_MESSAGE *m,uint8_t rtr);
extern void can_rx_filter(uint32_t id, uint32_t id_mask);



#if defined(__cplusplus) || defined(c_plusplus)
}
#endif



#endif
