#include <stdint.h>
#include "delay.h"


//one step takes 3 clock cycles !!! check this on cortex-m0/m3!!!
//possibly longer when executed from FLASH, since flash reading requires more cycles on M3 running at top speed
//SOLVED by defining experimentally obtained value DELAY_CYCLES in Makefile
//NOTE we use a fixed register to prevent compiler from using special registers, which might be slower/faster leading to irregular performance of the inlined instantiations
//NOTE: timing is not completely reliable, there can be flash read delays and instruction times are thus not
//fully predictable
//prevent unpredictable flash delays by placing it into RAM - section .data with extra .ramfunc (maybe not necessary)
//linker generates "veneers" for long branches and the code gets loaded to RAM together with initialized data by the startup routine
//not to waster RAM, this should be moved to a .c file and added into OBJS in the Makefile, inlining here makes no sense
//still it is not fully reliable and is not suitable for exact timing!


#ifndef DELAY_DEBUG
__attribute__ ((__section__(".data.ramfunc"))) 
void Delay(const uint32_t n_clock3) 
{
        asm volatile (
        "\n"
	"\tmov r3, %0\n"
	".align 2\n"
        "Lab%=:" "\n\t"
#if defined(cortex_m3)||defined(cortex_m4)
        "subs r3, r3, #1" "\n\t"
#endif
#ifdef cortex_m0
        "sub r3, r3, #1" "\n\t"
#endif
        "bne Lab%=" "\n\t"
	:
        : "r" (n_clock3)
        : "r3", "cc"
        );

return;
}

#else
inline void Delay(const uint32_t n_clock3)         
{
volatile uint32_t i;
for(i=0; i<(n_clock3>>3); ++i);
return;
}

#endif
