#ifndef __EEPROM_H__
#define __EEPROM_H__

#include <stdint.h>


#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern uint8_t   eepromReadU8   ( void * addr );
extern int8_t    eepromReadS8   ( void * addr );
extern uint16_t  eepromReadU16  ( void * addr );
extern int16_t   eepromReadS16  ( void * addr );
extern uint32_t  eepromReadU32  ( void * addr );
extern int32_t   eepromReadS32  ( void * addr );
extern uint64_t  eepromReadU64  ( void * addr );
extern int64_t   eepromReadS64  ( void * addr );
extern float  eepromReadF  ( void * addr );
extern void      eepromReadBuffer ( void * addr, uint8_t *buffer, uint32_t bufferLength);
extern void      eepromWriteU8  ( void * addr, uint8_t value );
extern void      eepromWriteS8  ( void * addr, int8_t value );
extern void      eepromWriteU16 ( void * addr, uint16_t value );
extern void      eepromWriteS16 ( void * addr, int16_t value );
extern void      eepromWriteU32 ( void * addr, uint32_t value );
extern void      eepromWriteS32 ( void * addr, int32_t value );
extern void      eepromWriteU64 ( void * addr, uint64_t value );
extern void      eepromWriteS64 ( void * addr, int64_t value );
extern void    eepromWriteF ( void * addr, float  value );

#define eeprom_read_byte(X) eepromReadU8((X)&0xffffL)
#define eeprom_read_short(X) eepromReadU16((X)&0xffffL)
#define eeprom_read_word(X) eepromReadU32((X)&0xffffL)
#define eeprom_read_float(X) eepromReadF((X)&0xffffL)

#define eeprom_write_byte(X,Y) eepromWriteU8((X)&0xffffL,(Y))
#define eeprom_write_short(X,Y) eepromWriteU16((X)&0xffffL,(Y))
#define eeprom_write_word(X,Y) eepromWriteU32((X)&0xffffL,(Y))
#define eeprom_write_float(X,Y) eepromWriteF((X)&0xffffL,(Y))




#if defined(__cplusplus) || defined(c_plusplus)
}
#endif


#endif
