/*
    Copyright (C) 2022 Jiri Pittner <jiri@pittnerovi.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

float steer_angle;
float wheel_speeds[4];
float gas_pedal;

void process_can_message_mycar(const CAN_VALUE *v, int8_t nsignals)
{
switch(v[0].group)
	{
	case mycar_STEER_ANGLE_SENSOR_CAN_ID:
		steer_angle = v[mycar_STEER_ANGLE_SENSOR_STEER_ANGLE_SIG_ITEM].value.floatval;
		break;
	case mycar_GAS_PEDAL_CAN_ID:
		gas_pedal = (float) v[mycar_GAS_PEDAL_GAS_PEDAL_SIG_ITEM].value.uint32;
		break;
	case mycar_WHEEL_SPEEDS_REAR_CAN_ID:
		wheel_speeds[2]= v[mycar_WHEEL_SPEEDS_REAR_WHEEL_SPEED_RR_SIG_ITEM].value.floatval;
		wheel_speeds[3]= v[mycar_WHEEL_SPEEDS_REAR_WHEEL_SPEED_RL_SIG_ITEM].value.floatval;
		break;
	case mycar_WHEEL_SPEEDS_FRONT_CAN_ID:
		wheel_speeds[0]= v[mycar_WHEEL_SPEEDS_FRONT_WHEEL_SPEED_FR_SIG_ITEM].value.floatval;
		wheel_speeds[1]= v[mycar_WHEEL_SPEEDS_FRONT_WHEEL_SPEED_FL_SIG_ITEM].value.floatval;
		break;
	}
}

