/*
    Copyright (C) 2022 Jiri Pittner <jiri@pittnerovi.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifdef OBD2_EXTRACT_FAVORITE_VALUES 
float engine_load;
float coolant_temperature;
float fuel_pressure;
float manifold_pressure;
float engine_speed;
float vehicle_speed;
float timing_advance;
float intake_air_temperature;
float mass_air_flow;
float throttle_position;
float run_time_since_engine_start;
float fuel_rail_pressure;
float fuel_gauge_pressure;
float fuel_tank_level;
float barometric_pressure;
float control_module_voltage;
float engine_oil_temperature;
float engine_fuel_rate;
float actual_engine_percent_torque;
#endif

//store some selected values
void process_can_message_obd2(const CAN_VALUE *v, int8_t nsignals)
{
#ifdef OBD2_EXTRACT_FAVORITE_VALUES 
switch(v[0].pid)
	{
	case 0x04:
		engine_load = v[0].value.floatval;
		break;
	case 0x05:
		coolant_temperature = v[0].value.floatval;
		break;
	case 0x0a:
		fuel_pressure  = v[0].value.floatval;
		break;
	case  0x0b:
		manifold_pressure   = v[0].value.floatval;
		break;
	case 0x0c:
		engine_speed =  v[0].value.floatval;
		break;
	case 0x0d:
		vehicle_speed =  v[0].value.floatval;
		break;
	case 0x0e:
		timing_advance =  v[0].value.floatval;
		break;
	case 0x0f:
		intake_air_temperature = v[0].value.floatval;
                break;
	case 0x10:
		mass_air_flow = v[0].value.floatval;
                break;
	case 0x11:
		throttle_position =  v[0].value.floatval;
		break;
	case 0x1f:
		run_time_since_engine_start  = v[0].value.floatval;
		break;
	case 0x22:
		fuel_rail_pressure = v[0].value.floatval;
                break;
        case 0x23:
		fuel_gauge_pressure = v[0].value.floatval;
                break;
	case 0x2f:
		fuel_tank_level  = v[0].value.floatval;
                break;
	case 0x33:
		barometric_pressure  = v[0].value.floatval;
                break;
	case 0x42:
		control_module_voltage = v[0].value.floatval;
                break;
	case 0x5c:
		engine_oil_temperature = v[0].value.floatval;
                break;
	case 0x5e:
		engine_fuel_rate = v[0].value.floatval;
                break;
	case 0x62:
		actual_engine_percent_torque  = v[0].value.floatval;
                break;


	}
#endif
}

