//undefine this - this is only for rev.0 test board 
#define PWMH_ON_PB3
#define RELAY_ON_PB4


/*
 * *      highvolt.c  ... firmware for high and low voltage power supply / xray based on  STM32F373VCT6 
 * *
 * *      Copyright (C) 2014-2015 Jiri Pittner <jiri@pittnerovi.com>
 * *
 * *      This program is free software: you can redistribute it and/or modify
 * *      it under the terms of the GNU General Public License as published by
 * *      the Free Software Foundation, either version 3 of the License, or
 * *      (at your option) any later version.
 * *
 * *      This program is distributed in the hope that it will be useful,
 * *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 * *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * *      GNU General Public License for more details.
 * *      You should have received a copy of the GNU General Public License
 * *      along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * *
 * *
 * */

//Makefile parameters:
//USART1=USART1_ON_PE01
//XTAL = 7372800ULL
//PLLMULT = 10



//TODO:
//@@@ LV range voltage measurement saturated at about 28.4V
//@@@@nefunguje dioda LV current limit!
//@@@display update prilis rychly - necitelne
//rtc routines ->millis() for ethershield
//improve random number seeding
//smt160 thermometer routines to control fans
//
//NOTE:
//remote "shell" over ethernet: nc -lup 10000 < /dev/null & nc -u highvolt1 10000
//
//Be-window tube from baggage inspection machine:
//150kv/10mA max
//
//dental tube: 
//1.85A filament current, 2k2 grid resistor, 0.45mA anode current at 35kv
//
//xray tube chirana 30-40kv, 0.2-0.5mA, 4.1V 3.3A zhaveni
//6bc-1 30 - 40kV and current of 200 - 500uA. zhaveni 6.3V 0.6A ! pozor na schema - asi vyzaduje galv. oddeleny zhavici zdroj!



//maximum ratings of the Xray tube
#define XV_volts_max 50000.
#define XV_amps_max 0.0005
#define XV_filament_volts_max 5.5
#define XV_filament_amps_max 3.3

//maximum to prevent saturation problems
//NOTE! this value is CRITICAL! If too large, the flyback core might saturate and destruction of the FET follows
//if working from hard enough power supply. Further components might die as well!
//Test for the maximum value running from current-limited power supply!
//The value depends on the frequency.

#define HV_maxduty 0.5

//notice: do not use VCC3A as external SDADC reference, does not work properly - pin is not connected to external power source!!!
/*hardware: STM32F373VCT6,  XTAL = 7372800ULL , PLLMULT = 10
 * PA0 = RELAY
 * PA1 = PWMH2 - complementary to PB6 TIM15CH1N for push-pull
 * PA2 = USART2TX
 * PA3 = USART2RX
 * PA4 = HV_ADCV as ADCIN4
 * PA5 = HV_ADCA as ADCIN5
 * PA6 = HV_ADCA2 as ADCIN6
 * PA7 = ADC_VIN as ADCIN7
 * PA8-12 = LEDS
 * PA13-15=JTAG
 *
 * PB0 = VREF2.5 as ADCIN8 
 * PB1 = STEP_EN1
 * PB2 = STEP_EN2
 * PB3,4 = JTAG   //alternatively PB3 as tim13ch1
 * PB5=PWML as tim3ch2
 * PB6=PWMH as tim4ch1 OR TIM15CH1
 * PB7=I2C1SDA
 * PB8=I2C1SCL
 * PB9=STEP_1A
 * PB10=STEP_1B
 * PB14=STEP_2A
 * PB15=STEP_2B
 *
 * PC0 = LV_ADCV  as ADCIN10
 * PC1= LV_ADCA as ADCIN11
 * PC2= LV_ADCA2 as ADCIN12
 * PC3=  LV_ADCA3 as ADCIN13
 * PC4=LAN_INT
 * PC5=LAN_RESET
 * PC6=LAN_CS
 * PC7=LAN_SPI1SCK
 * PC8=LAN_SPI1MISO
 * PC9=LAN_SPI1MOSI
 * PC10=USART3TX
 * PC11=USART3RX
 *
 * PD0-3=LCD_DB4-7
 * PD4=LCD_E
 * PD5=LCD_RW
 * PD6=LCD_RS
 * PD7=LCD_LIGHT
 * PD8=LV_SDADCV as SDADC3IN6P 
 * PD9=LV_SDADCA as SDADC3IN5P
 * PD10=LV_SDADCA2 as SDADC3IN4P
 * PD11=LV_SDADCA3 as SDADC3IN3P
 * PD12=VREF2.5 as SDADC3IN2P
 * note SDADC3 is DMA2ch5
 *
 * PE0=USART1TX
 * PE1=USART1RX
 * PE2=ROTL
 * PE3=ROTR
 * PE4=ROTP
 * PE5=BUTL
 * PE6=BUTR
 * PE7 = HV_SDADCV as SDADC2_AIN5P 
 * PE8 = HV_SDADCA as SDADC2_AIN8P DMA2ch4
 * PE9 = HV_SDADCA2 as SDADC2_AIN7P
 * PE10=AUX0
 * PE12 = VENTILATOR
 * PE13= HV_EXCITER
 * PE14=AUX1
 *
 * PF2=SMT1
 * PF3=SMT2
 * PF9=SWL
 * PF10=SWR
 *
 * */

//calibration constants
//
#define VCC3A 3.300
#define VREFINT2 1.800
#define VREF25 2.5013
#define R_Isense 0.01
#define R_Vsense 937500000
#define R302 10000.
#define R305 1000.
#define R323 19968.
#define R324 2196.8
#define R328 19962.
#define R329 2198.8
#define R332 19985.
#define R333 2215.1
#define R507 996.1
#define R508 3292.
#define R509 99600.
#define R510 999.5
#define R511 46900.
#define R512 997.1
#define R513 32930.
#define R514 9990.
#define R516 2669.
#define R517 2694.7
#define R518 2698.3
#define R519 997.8
#define R520 995.5
#define R525 1e1
#define R526 1e1
#define R530 1e7
#define R531 1e7
#define R528 1e5
#define R529 1e5
#define R521 998.6
#define R602 11985.
#define R603 997.2
//see also LV_vadcoffset later
//end calibration

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <setjmp.h>
#include <errno.h>

#ifndef USART1_ON_PE01
#error USART1_ON_PE01 must be defined
#endif

#include "usart123.h"
#include "delay.h"
#include "lcd.h"
#include "stm32f37x_gpio.h"
#include "stm32f37x_rcc.h"
#include "stm32f37x_pwr.h"
#include "stm32f37x_tim.h"
#include "stm32f37x_exti.h"
#include "stm32f37x_dma.h"
#include "stm32f37x_adc.h"
#include "stm32f37x_sdadc.h"
#include "stm32f37x_i2c.h"
#include "stm32f37x_misc.h"
#include "stm32f37x_syscfg.h"

uint8_t lan_buf[LAN_BUFFER_SIZE+3];
#include "lan.h"

//LAN parameters
uint8_t mymac[6] = {0x54,0x55,0x58,0x10,0x00,0x25}; //set some arbitrary one for DHCP
uint8_t dstmac[6] = {0,0,0,0,0,0};
uint8_t myip[4] = {0,0,0,0}; //use DHCP
uint8_t mygwip[4] = {0,0,0,0};
uint8_t dhcpsrvip[4] = {0,0,0,0};
uint8_t mynetmask[4] = {255,255,255,0};
uint8_t dnsip2[4] = {0,0,0,0};
uint8_t destip[4] = {0,0,0,0};
short dst_port = 10000; //answer to this port number regardless from which port it came from
short src_port = 10000; //our from port

//whitelist of IPs allowed to send commands
#define N_WHITE_IP 1
static const uint8_t ip_whitelist[N_WHITE_IP][4]={
	{192,168,0,20},
	};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//SDADC ROUTINES
//
//
uint32_t randomseed=0;

#define SDADC_INIT_TIMEOUT   2000 /* ~ about two SDADC clock cycles after INIT is set */
#define SDADC_CAL_TIMEOUT    (40*30720L) /*  ~5.12 ms at 6 MHz  in a single calibration sequence */

static float vrefint2=VREFINT2;


int32_t read_regSDADC(SDADC_TypeDef *SDADC, uint16_t nrep)
{
//discard first one
SDADC_SoftwareStartConv(SDADC);
while(SDADC_GetFlagStatus(SDADC,SDADC_FLAG_REOC)!=SET) ++randomseed;
randomseed+=SDADC_GetConversionValue(SDADC); 

int32_t r=0;
do
	{
	SDADC_SoftwareStartConv(SDADC);
	while(SDADC_GetFlagStatus(SDADC,SDADC_FLAG_REOC)!=SET) ++randomseed;
	r += SDADC_GetConversionValue(SDADC); 
	}
while(--nrep);
return r;
}

uint32_t uread_regSDADC(SDADC_TypeDef *SDADC, uint16_t nrep)
{
//discard first one
SDADC_SoftwareStartConv(SDADC);
while(SDADC_GetFlagStatus(SDADC,SDADC_FLAG_REOC)!=SET);
randomseed+=SDADC_GetConversionValue(SDADC); 

uint32_t r=0;
do
	{
	SDADC_SoftwareStartConv(SDADC);
	while(SDADC_GetFlagStatus(SDADC,SDADC_FLAG_REOC)!=SET) ++randomseed;
	r += (uint16_t) ((uint16_t)32768+SDADC_GetConversionValue(SDADC)); 
	}
while(--nrep);
return r;
}


uint32_t uread_injSDADC(SDADC_TypeDef *SDADC, uint32_t SDADC_Channel, uint16_t nrep, uint8_t *err)
{
*err=0;
//discard first one
SDADC_InjectedChannelSelect(SDADC,SDADC_Channel);
SDADC_SoftwareStartInjectedConv(SDADC);
while(SDADC_GetFlagStatus(SDADC,SDADC_FLAG_JEOC)!=SET);
uint32_t chx;
SDADC_GetInjectedConversionValue(SDADC, &chx);

uint32_t r=0;
do
        {
	SDADC_SoftwareStartInjectedConv(SDADC);
        while(SDADC_GetFlagStatus(SDADC,SDADC_FLAG_JEOC)!=SET) ++randomseed;
        uint16_t tmp = (uint16_t) ((uint16_t)32768+SDADC_GetInjectedConversionValue(SDADC, &chx));
	r += tmp;
	if(tmp == 0xffff) {*err=1; return;} //overflow
	if(chx!=SDADC_Channel) {*err=2; return;}
        }
while(--nrep);
return r;
}

#if 0
// PE7 = HV_SDADCV as SDADC1_AIN3P DMA2ch3

uint8_t init_SDADC1(uint8_t use_dma)
{
  uint32_t SDADCTimeout = 0;

 SDADC_DeInit(SDADC1); 

  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR,ENABLE);
  PWR_SDADCAnalogCmd(PWR_SDADCAnalog_1, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SDADC1, ENABLE);
  RCC_SDADCCLKConfig(RCC_SDADCCLK_SYSCLK_Div12); /* Set the SDADC divider: The SDADC should run max@6MHz, we run at 6.144 */
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOE, ENABLE);

  /* allowed SDADC1 channel 3 single ended on pe7 */
  GPIO_InitTypeDef GPIO_InitStructure;
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
  GPIO_Init(GPIOE, &GPIO_InitStructure);

  SDADC_Cmd(SDADC1, ENABLE);
  delay_ms(5);


  /* Enter initialization mode */
  SDADC_InitModeCmd(SDADC1, ENABLE);
  SDADCTimeout = SDADC_INIT_TIMEOUT;
  /* wait for INITRDY flag to be set */
  while((SDADC_GetFlagStatus(SDADC1, SDADC_FLAG_INITRDY) == RESET) && (--SDADCTimeout != 0));

  if(SDADCTimeout == 0)
  {
    /* INITRDY flag can not set */
    return 1;
  }
SDADC_InitTypeDef SDADC_InitStruct;
SDADC_InitStruct.SDADC_Channel = SDADC_Channel_3;
SDADC_InitStruct.SDADC_ContinuousConvMode = use_dma?ENABLE:DISABLE;
SDADC_InitStruct.SDADC_FastConversionMode = DISABLE;
SDADC_Init(SDADC1, &SDADC_InitStruct);


SDADC_AINStructTypeDef SDADC_AINStructure;
SDADC_AINStructInit(&SDADC_AINStructure);
SDADC_AINStructure.SDADC_InputMode = SDADC_InputMode_SEZeroReference;
SDADC_AINStructure.SDADC_Gain = SDADC_Gain_1;
SDADC_AINStructure.SDADC_CommonMode = SDADC_CommonMode_VSSA; 
SDADC_AINStructure.SDADC_Offset = 0;
SDADC_AINInit(SDADC1, SDADC_Conf_0, &SDADC_AINStructure);
SDADC_ChannelConfig(SDADC1, SDADC_Channel_3, SDADC_Conf_0);

SDADC_InitModeCmd(SDADC1, DISABLE);

SDADC_CalibrationSequenceConfig(SDADC1, SDADC_CalibrationSequence_1);
SDADC_StartCalibration(SDADC1);
SDADCTimeout = SDADC_CAL_TIMEOUT;
while((SDADC_GetFlagStatus(SDADC1, SDADC_FLAG_EOCAL) == RESET) && (--SDADCTimeout != 0)) ++randomseed;
if(SDADCTimeout == 0)
  {
    return 2;
  }
return 0;
}

#endif


//PE7 = HV_SDSDCV as SDADC2_AIN5P
//PE9 = HV_SDADCA2 as SDADC2_AIN7P
//PE8 = HV_SDADCA as SDADC2_AIN8P DMA2ch4
 
uint8_t init_SDADC2(uint8_t use_dma, const uint32_t *gains, const uint32_t *configs, const uint32_t *channels, uint32_t *buffer, uint16_t blocksize, uint8_t nchan)
{
uint32_t SDADCTimeout = 0;

 SDADC_DeInit(SDADC2); 

  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR,ENABLE);
  PWR_SDADCAnalogCmd(PWR_SDADCAnalog_2, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SDADC2, ENABLE);
  RCC_SDADCCLKConfig(RCC_SDADCCLK_SYSCLK_Div12); /* Set the SDADC divider: The SDADC should run max@6MHz, we run at 6.144 */
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOE, ENABLE);

  /* allowed SDADC2 channel 5,8,7 single ended on pe7,8,9 */
  GPIO_InitTypeDef GPIO_InitStructure;
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9;
  GPIO_Init(GPIOE, &GPIO_InitStructure);

  SDADC_Cmd(SDADC2, ENABLE);
  delay_ms(5);

  /* Enter initialization mode */
  SDADC_InitModeCmd(SDADC2, ENABLE);
  SDADCTimeout = SDADC_INIT_TIMEOUT;
  /* wait for INITRDY flag to be set */
  while((SDADC_GetFlagStatus(SDADC2, SDADC_FLAG_INITRDY) == RESET) && (--SDADCTimeout != 0)) ++randomseed;

  if(SDADCTimeout == 0)
  {
    /* INITRDY flag can not set */
    return 1;
  }


SDADC_InitTypeDef SDADC_InitStruct;
SDADC_InitStruct.SDADC_Channel = SDADC_Channel_5; //here only one regular channel can be specified
SDADC_InitStruct.SDADC_ContinuousConvMode = use_dma?ENABLE:DISABLE;
SDADC_InitStruct.SDADC_FastConversionMode = DISABLE;
SDADC_Init(SDADC2, &SDADC_InitStruct);


SDADC_AINStructTypeDef SDADC_AINStructure;
SDADC_AINStructInit(&SDADC_AINStructure);
SDADC_AINStructure.SDADC_InputMode = SDADC_InputMode_SEZeroReference;
SDADC_AINStructure.SDADC_Gain = gains[0];
SDADC_AINStructure.SDADC_CommonMode = SDADC_CommonMode_VSSA; 
SDADC_AINStructure.SDADC_Offset = 0;
SDADC_AINInit(SDADC2, SDADC_Conf_0, &SDADC_AINStructure);
SDADC_AINStructure.SDADC_Gain = gains[1];
SDADC_AINInit(SDADC2, SDADC_Conf_1, &SDADC_AINStructure);
SDADC_AINStructure.SDADC_Gain = gains[2];
SDADC_AINInit(SDADC2, SDADC_Conf_2, &SDADC_AINStructure);


uint8_t i;
for(i=0; i<nchan; ++i) SDADC_ChannelConfig(SDADC2, channels[i], configs[i]);

SDADC_CalibrationSequenceConfig(SDADC2, SDADC_CalibrationSequence_3);  //needed since we use all three configs

SDADC_InitModeCmd(SDADC2, DISABLE);

uint32_t tmp=0;
for(i=0; i<nchan; ++i) tmp |= channels[i];
SDADC_InjectedChannelSelect(SDADC2,tmp);


SDADC_StartCalibration(SDADC2);
SDADCTimeout = SDADC_CAL_TIMEOUT*3;
while((SDADC_GetFlagStatus(SDADC2, SDADC_FLAG_EOCAL) == RESET) && (--SDADCTimeout != 0)) ++randomseed;
if(SDADCTimeout == 0)
  {
    return 2;
  }

//check the offsets
{
uint32_t tmp = 0;
tmp = (uint32_t)((uint32_t)SDADC2 + 0x00000020);
uint16_t offset0 = *(__IO uint32_t *) (tmp);
tmp = (uint32_t)((uint32_t)SDADC2 + 0x00000024);
uint16_t offset1 = *(__IO uint32_t *) (tmp);
tmp = (uint32_t)((uint32_t)SDADC2 + 0x00000028);
uint16_t offset2 = *(__IO uint32_t *) (tmp);
printf("SDADC2 offsets %d %d %d\n",offset0,offset1,offset2);
}

if(!use_dma) return 0;


RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA2, ENABLE);

static DMA_InitTypeDef DMA_InitStruct;

  DMA_StructInit(&DMA_InitStruct);
  DMA_InitStruct.DMA_PeripheralBaseAddr = (uint32_t)&(SDADC2->JDATAR);
  DMA_InitStruct.DMA_MemoryBaseAddr = (uint32_t)buffer;
  DMA_InitStruct.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStruct.DMA_BufferSize = blocksize*nchan;
  DMA_InitStruct.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStruct.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStruct.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Word;
  DMA_InitStruct.DMA_MemoryDataSize = DMA_MemoryDataSize_Word;
  DMA_InitStruct.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStruct.DMA_Priority = DMA_Priority_Medium;
  DMA_InitStruct.DMA_M2M = DMA_M2M_Disable;
  DMA_Init(DMA2_Channel4, &DMA_InitStruct);


DMA_Cmd(DMA2_Channel4, DISABLE);
DMA_ClearFlag(DMA2_FLAG_TC4); //clear transfer complete to allow next one
DMA_ClearFlag(DMA2_FLAG_TE4); //clear transfer error
DMA_Cmd(DMA2_Channel4, ENABLE);
DMA_ITConfig(DMA2_Channel4,DMA_IT_TC,ENABLE);


SDADC_DMAConfig(SDADC2,SDADC_DMATransfer_Injected,ENABLE);
SDADC_InjectedContinuousModeCmd(SDADC2,ENABLE);
SDADC_SoftwareStartInjectedConv(SDADC2);

NVIC_InitTypeDef NVIC_InitStructure;
NVIC_InitStructure.NVIC_IRQChannel = DMA2_Channel4_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);

return 0;
}


uint8_t init_SDADC3(uint8_t use_dma, const uint32_t *gains,  const uint32_t *configs, const uint32_t *channels, uint32_t *buffer, uint16_t blocksize, uint8_t nchan)
{
  uint32_t SDADCTimeout = 0;

 SDADC_DeInit(SDADC3); 

  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR,ENABLE);
  PWR_SDADCAnalogCmd(PWR_SDADCAnalog_3, ENABLE);
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SDADC3, ENABLE);
  RCC_SDADCCLKConfig(RCC_SDADCCLK_SYSCLK_Div12); /* Set the SDADC divider: The SDADC should run max@6MHz, we run at 6.144 */
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOD, ENABLE);



  /* allowed SDADC3 channel 2,3,4,5,6 single ended on pd12,11,10,9,8 */
  GPIO_InitTypeDef GPIO_InitStructure;
  GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12;
  GPIO_Init(GPIOD, &GPIO_InitStructure);


  SDADC_Cmd(SDADC3, ENABLE);
  delay_ms(5);

  /* Enter initialization mode */
  SDADC_InitModeCmd(SDADC3, ENABLE);
  SDADCTimeout = SDADC_INIT_TIMEOUT;
  /* wait for INITRDY flag to be set */
  while((SDADC_GetFlagStatus(SDADC3, SDADC_FLAG_INITRDY) == RESET) && (--SDADCTimeout != 0));

  if(SDADCTimeout == 0)
  {
    /* INITRDY flag can not set */
    return 1;
  }


SDADC_InitTypeDef SDADC_InitStruct;
SDADC_InitStruct.SDADC_Channel = SDADC_Channel_2; //here only one regular channel can be specified
SDADC_InitStruct.SDADC_ContinuousConvMode = use_dma?ENABLE:DISABLE; 
SDADC_InitStruct.SDADC_FastConversionMode = DISABLE;
SDADC_Init(SDADC3, &SDADC_InitStruct);


SDADC_AINStructTypeDef SDADC_AINStructure;
SDADC_AINStructInit(&SDADC_AINStructure);
SDADC_AINStructure.SDADC_InputMode = SDADC_InputMode_SEZeroReference;
SDADC_AINStructure.SDADC_Gain = gains[0];
SDADC_AINStructure.SDADC_CommonMode = SDADC_CommonMode_VSSA; 
SDADC_AINStructure.SDADC_Offset = 0;
SDADC_AINInit(SDADC3, SDADC_Conf_0, &SDADC_AINStructure);
SDADC_AINStructure.SDADC_Gain = gains[1];
SDADC_AINInit(SDADC3, SDADC_Conf_1, &SDADC_AINStructure);
SDADC_AINStructure.SDADC_Gain = gains[2];
SDADC_AINInit(SDADC3, SDADC_Conf_2, &SDADC_AINStructure);


SDADC_ChannelConfig(SDADC3, SDADC_Channel_2, SDADC_Conf_2);

uint8_t i;
for(i=0; i<nchan; ++i) SDADC_ChannelConfig(SDADC3, channels[i], configs[i]);

SDADC_CalibrationSequenceConfig(SDADC3, SDADC_CalibrationSequence_3); //needed since we use all three configs
SDADC_InitModeCmd(SDADC3, DISABLE);

uint32_t tmp=0;
for(i=0; i<nchan; ++i) tmp |= channels[i];
SDADC_InjectedChannelSelect(SDADC3,tmp);

SDADC_StartCalibration(SDADC3);
SDADCTimeout = SDADC_CAL_TIMEOUT*3;
while((SDADC_GetFlagStatus(SDADC3, SDADC_FLAG_EOCAL) == RESET) && (--SDADCTimeout != 0)) ++randomseed;
if(SDADCTimeout == 0) return 2;


//check the offsets
{
uint32_t tmp = 0;
tmp = (uint32_t)((uint32_t)SDADC3 + 0x00000020);
uint16_t offset0 = *(__IO uint32_t *) (tmp);
tmp = (uint32_t)((uint32_t)SDADC3 + 0x00000024);
uint16_t offset1 = *(__IO uint32_t *) (tmp);
tmp = (uint32_t)((uint32_t)SDADC3 + 0x00000028);
uint16_t offset2 = *(__IO uint32_t *) (tmp);
printf("SDADC3 offsets %d %d %d\n",offset0,offset1,offset2);
}

if(!use_dma) return 0;


RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA2, ENABLE);

static DMA_InitTypeDef DMA_InitStruct;

  DMA_StructInit(&DMA_InitStruct);
  DMA_InitStruct.DMA_PeripheralBaseAddr = (uint32_t)&(SDADC3->JDATAR);
  DMA_InitStruct.DMA_MemoryBaseAddr = (uint32_t)buffer;
  DMA_InitStruct.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStruct.DMA_BufferSize = blocksize*nchan;
  DMA_InitStruct.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStruct.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStruct.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Word;
  DMA_InitStruct.DMA_MemoryDataSize = DMA_MemoryDataSize_Word;
  DMA_InitStruct.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStruct.DMA_Priority = DMA_Priority_Medium;
  DMA_InitStruct.DMA_M2M = DMA_M2M_Disable;
  DMA_Init(DMA2_Channel5, &DMA_InitStruct);


DMA_Cmd(DMA2_Channel5, DISABLE);
DMA_ClearFlag(DMA2_FLAG_TC5); //clear transfer complete to allow next one
DMA_ClearFlag(DMA2_FLAG_TE5); //clear transfer error
DMA_Cmd(DMA2_Channel5, ENABLE);
DMA_ITConfig(DMA2_Channel5,DMA_IT_TC,ENABLE);


SDADC_DMAConfig(SDADC3,SDADC_DMATransfer_Injected,ENABLE);
SDADC_InjectedContinuousModeCmd(SDADC3,ENABLE);
SDADC_SoftwareStartInjectedConv(SDADC3);

NVIC_InitTypeDef NVIC_InitStructure;
NVIC_InitStructure.NVIC_IRQChannel = DMA2_Channel5_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);

return 0;
}

uint32_t truerandom(void) {return randomseed;} //actually is very bad, about 1 bit of entropy - do sometimes something better

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//higher level measurement and control


volatile uint8_t no_feedback_mode=0;
volatile uint8_t xray_mode=0;
volatile float LV_duty=0.; 
volatile float HV_duty=0.;

#define LV_NREP 4
//larger than 8 bits to switch it off
#define LV_printmod 0xffff
#define LV_NCHAN 4

static const float LV_vadcoffset[LV_NCHAN] = {0.,0.,0.,0.}; //calibration

const uint32_t LV_channels[LV_NCHAN] = {SDADC_Channel_3,SDADC_Channel_4,SDADC_Channel_5,SDADC_Channel_6};
const float LV_factors[LV_NCHAN] = { // input of amplification chain / input of ADC
	1./(R323/R324)/(1.+R328/R329)/(1.+R332/R333),
	1./(R323/R324)/(1.+R328/R329),
	1./(R323/R324),
	1.*(R302+R305)/R305
	};
const uint32_t LV_sdadc_gains[3] = {SDADC_Gain_1_2,SDADC_Gain_1_2,SDADC_Gain_1_2,}; //there are just 3 configurations
const uint32_t LV_sdadc_configs[LV_NCHAN] = {0,0,1,2};
const float LV_gainfactors[LV_NCHAN] = {.5,.5,.5,.5};

volatile uint32_t LV_data[LV_NREP*LV_NCHAN];

volatile float LV_volts, LV_volts_prev,LV_volts_set,LV_amps,LV_amps_max;
volatile uint8_t LV_active=0;

static volatile uint16_t pwml_period;
static volatile uint32_t overcurrent_recent=0;

//interrupt to process data after complete DMA transfer
void DMA2_Channel5_IRQHandler(void)
{
DMA_ClearITPendingBit(DMA2_IT_TC5);
static volatile uint8_t ibuf=0;
static volatile uint8_t ifill=0;
static volatile uint8_t LVirqpass=0;
++LVirqpass;
uint16_t i;
uint32_t sum[LV_NCHAN];
uint16_t hist[LV_NCHAN];
memset(sum,0,LV_NCHAN*sizeof(uint32_t));
memset(hist,0,LV_NCHAN*sizeof(uint16_t));
for(i=0; i<LV_NREP*LV_NCHAN; ++i)
	{
	uint8_t ch = (LV_data[i]>>24) - 3; //we start with channel 3
	if(ch>=LV_NCHAN) continue;
	uint16_t tmp = (uint16_t)32768 + (uint16_t)(LV_data[i]&0xffff);
		{
		++hist[ch];
		sum[ch] += tmp;
		}
	}

#if 0
if((LVirqpass&LV_printmod)==LV_printmod) for(i=0; i<LV_NCHAN; ++i)
	{
	printf("ch %d: %d %d; ",i,hist[i],sum[i]);
	}
if((LVirqpass&LV_printmod)==LV_printmod) printf("\n");
#endif

float vadc[LV_NCHAN];
for(i=0; i<LV_NCHAN; ++i) vadc[i] = sum[i]*vrefint2/hist[i]/LV_gainfactors[i]/65536.;


#if 0
if((LVirqpass&LV_printmod)==LV_printmod) for(i=0; i<LV_NCHAN; ++i)
        {
        printf("adc%d= %f fakt %f ",i,vadc[i],LV_factors[i]);
        }
#endif


LV_volts = LV_factors[3]*(vadc[3]-LV_vadcoffset[3]);

float vdrop;

for(i=0; i<LV_NCHAN-1; ++i) //measure current from the first non-saturated channel
	{
	if(vadc[i]<VCC3A-0.1)
		{
		vdrop = (vadc[i]-LV_vadcoffset[i]) * LV_factors[i];
		//if((LVirqpass&LV_printmod)==LV_printmod) printf("LV_IRange %d vdrop %f ",i,vdrop);
		break;
		}
	}

LV_amps = vdrop/ R_Isense;
LV_volts -= vdrop; //we should fix the voltage at output clamps


//adaptive PWM adjustment
if(no_feedback_mode) {LV_volts_prev=LV_volts; goto LV_end;}

uint16_t step=1;
uint16_t old_ccr2 = TIM3->CCR2;

float LV_volts_set_eff = LV_active? LV_volts_set : 0.;
led(1,LV_active);


overcurrent_recent >>= 1;
float ampsratio=LV_amps/LV_amps_max;
if(ampsratio>1.01) //overcurrent
	{
	overcurrent_recent+= 0x1000000; 
	led(3,1);
	if(ampsratio>1.5) step=2;
	if(ampsratio>2.) step=5;
	if(ampsratio>5.) step=10;
	if(ampsratio>10.) step=50;
	while(step)
                {
                if(TIM3->CCR2 > step+6) {TIM3->CCR2-=step; break;}
                step>>=1;
                }
	}

else //regulate voltage
{
led(3,0);
if(ampsratio<0.9)
	{
	if(fabs(LV_volts-LV_volts_set_eff)>.5) step=5;
	if(fabs(LV_volts-LV_volts_set_eff)>1.) step=10;
	if(fabs(LV_volts-LV_volts_set_eff)>5.) step=pwml_period/200;
	if(fabs(LV_volts-LV_volts_set_eff)>10.) step=pwml_period/100;
	}

if(overcurrent_recent) step=1;

//the regulation is slow when little current is drawn and we have to somehow adjust for that
//

if(LV_volts < LV_volts_set_eff)
	{ 
	while(step)
		{
		if(TIM3->CCR2 < pwml_period-step-1) {TIM3->CCR2+=step; break;}
		step>>=1;
		}
	}
if(LV_volts > LV_volts_set_eff)
	{
	while(step)
		{
		if(TIM3->CCR2 > step) {TIM3->CCR2-=step; break;} 
		step>>=1;
		}
	}
//printf("TEST %d %d %d\n",TIM3->CCR2,step,LV_volts>LV_volts_set_eff?-1:1);
}

LV_duty = TIM3->CCR2/(float)pwml_period;
//end regulation
//


LV_volts_prev=LV_volts;

LV_end:
//print info
if((LVirqpass&LV_printmod)==LV_printmod)
	{
	printf("Set %4.1f V=%6.2f Imax=%5.2f I=%5.2f; old=%4d new=%4d of %5d\n",LV_volts_set_eff,LV_volts,LV_amps_max,LV_amps,old_ccr2,TIM3->CCR2,pwml_period);
	}
}


////////////////////////////////////////////////////////////////////////////////////////////
//high voltage interrupt handler

#define HV_NREP 64
#define HV_printmod 0xffff
#define HV_NCHAN 3

//two alternate HV modules 
#define N_HV 2
static const float HV_amps_sense[N_HV] = {1./R510+1./R512,1./R510+1./R512};
static const float HV_amps_offset[N_HV] = {4e-6,0.}; //experimentally calibrated
static const float HV_amps_saturation[N_HV] = {.009,.1};// formal measurement output if current ADC  is saturated

//select hardware version
#define hv_module 0 //high voltage
//#define hv_module 1 //medium voltage



const uint32_t HV_channels[HV_NCHAN] = {SDADC_Channel_5,SDADC_Channel_7,SDADC_Channel_8};
const float HV_factors[N_HV][HV_NCHAN] = {//input of amplification chain/input of ADC
	{ (R_Vsense+R509+R511)/(R509+R511)*(R516+R520)/R520, 1./(R513/R507)*(R517+R519)/R519, 1./(R514/R508)*(R518+R521)/R521},
	{(R531+R530+R529+R528)/(R529+R528)*(R516+R520)/R520,1./(R513/R507)*(R517+R519)/R519, 1./(R514/R508)*(R518+R521)/R521}
	};
const uint32_t HV_sdadc_gains[3] = {SDADC_Gain_1_2,SDADC_Gain_1_2,SDADC_Gain_1_2,}; //there are just 3 configurations
const uint32_t HV_sdadc_configs[HV_NCHAN] = {0,1,2};
const float HV_gainfactors[HV_NCHAN] = {.5,.5,.5};

volatile uint32_t HV_data[HV_NREP*HV_NCHAN];

volatile float HV_volts,HV_volts_set,HV_amps,HV_amps_max;
volatile uint8_t HV_active=0;
volatile uint8_t HV_remote=0;

static uint16_t pwmh_period;


//interrupt to process data after complete DMA transfer
void DMA2_Channel4_IRQHandler(void)
{
DMA_ClearITPendingBit(DMA2_IT_TC4);
static volatile float volts_prev=0;
static volatile float amps_prev=0;
static volatile uint8_t HVirqpass=0;
++HVirqpass;
uint16_t i;
uint32_t sum[HV_NCHAN];
uint16_t hist[HV_NCHAN];
memset(sum,0,HV_NCHAN*sizeof(uint32_t));
memset(hist,0,HV_NCHAN*sizeof(uint16_t));
for(i=0; i<HV_NREP*HV_NCHAN; ++i)
	{
	uint8_t ch = (HV_data[i]>>24) - 5; if(ch>0) ch--; //5,7,8 -> 0,1,2
	if(ch>=HV_NCHAN) continue;
	uint16_t tmp = (uint16_t)32768 + (uint16_t)(HV_data[i]&0xffff);
		{
		++hist[ch];
		sum[ch] += tmp;
		}
	}

/*
if((HVirqpass&HV_printmod)==HV_printmod) for(i=0; i<HV_NCHAN; ++i)
	{
	printf("ch %d: %d %d; ",i,hist[i],sum[i]);
	}
if((HVirqpass&HV_printmod)==HV_printmod) printf("\n");
*/


float vadc[HV_NCHAN];
for(i=0; i<HV_NCHAN; ++i) vadc[i] = sum[i]*vrefint2/hist[i]/HV_gainfactors[i]/65536.;

if((HVirqpass&HV_printmod)==HV_printmod) 
    {
    for(i=0; i<HV_NCHAN; ++i)
        {
        printf("adc%d= %5.3f ",i,vadc[i]);
        }
    printf("\n");
    }


HV_volts = HV_factors[hv_module][0]*vadc[0];

float vdrop;

for(i=1; i<HV_NCHAN; ++i) //measure current from the first non-saturated channel
	{
	if(vadc[i]<2.75) //saturation of TL084 occurs before
		{
		vdrop = vadc[i] * HV_factors[hv_module][i];
		if((HVirqpass&HV_printmod)==HV_printmod) printf("HV_IRange %d ",i);
		goto non_saturated;
		}
	}
//all channels saturated
vdrop = HV_amps_saturation[hv_module]/HV_amps_sense[hv_module];

non_saturated:

HV_amps = vdrop*HV_amps_sense[hv_module];
if(HV_active) HV_amps += HV_amps_offset[hv_module];
HV_amps -= HV_volts/R_Vsense; //current through the high voltage sense resistor has to be subtracted to get the "user's" current

//damp possible oscillations
const float dampfactor=0.5;
HV_amps = (dampfactor*HV_amps+(1.-dampfactor)*amps_prev);
HV_volts = (dampfactor*HV_volts+(1.-dampfactor)*volts_prev);
amps_prev=HV_amps;
volts_prev=HV_volts;

if(no_feedback_mode) goto HV_end;

//adaptive PWM adjustment
//
//new board version: pb6
#ifdef PWMH_ON_PB3
#define TIM_PWMH TIM13
#else
#define TIM_PWMH TIM4
#endif

uint16_t step=1;
uint16_t old_ccr1 = TIM_PWMH->CCR1;
uint16_t max_ccr1 = HV_maxduty*pwmh_period;

float HV_volts_set_eff = HV_active? HV_volts_set : 0;
led(0,HV_active);

float ampsratio=HV_amps/HV_amps_max;
if(ampsratio>1.01) //overcurrent 
	{
	led(4,1);
	if(ampsratio>1.2) step=3;
	if(ampsratio>1.5) step=10;
	if(ampsratio>2.) step=20;
	if(ampsratio>5.) step=50;
	while(step)
                {
                if(TIM_PWMH->CCR1 > step+6) {TIM_PWMH->CCR1-=step; break;}
                step>>=1;
                }
	}

else //regulate voltage
{
led(4,0);
if(ampsratio<0.9)
	{
	if(fabs(HV_volts-HV_volts_set_eff)>.5e3) step=4;
	if(fabs(HV_volts-HV_volts_set_eff)>1.e3) step=10;
	if(ampsratio<0.7 && fabs(HV_volts-HV_volts_set_eff)>2.e3) step=pwmh_period/150;
	if(ampsratio<0.5 && fabs(HV_volts-HV_volts_set_eff)>5.e3) step=pwmh_period/50;
	if(ampsratio<0.4 && fabs(HV_volts-HV_volts_set_eff)>10.e3) step=pwmh_period/20;
	}


if(HV_volts+10. < HV_volts_set_eff)
	{ 
	while(step)
		{
		if(TIM_PWMH->CCR1 < max_ccr1-step-1) {TIM_PWMH->CCR1+=step; break;}
		step>>=1;
		}
	}
if(HV_volts-10. > HV_volts_set_eff)
	{
	while(step)
		{
		if(TIM_PWMH->CCR1 > step) {TIM_PWMH->CCR1-=step; break;} 
		step>>=1;
		}
	}
}

HV_duty = TIM_PWMH->CCR1/(float)pwmh_period;
//end regulation

HV_end:
//print info
if((HVirqpass&HV_printmod)==HV_printmod)
	{
	printf("Set %4.1f V=%6.2f Imax=%5.2f I=%6.3f; old=%4d new=%4d of %5d\n",HV_volts_set_eff,HV_volts,1000*HV_amps_max,1000*HV_amps,old_ccr1,TIM_PWMH->CCR1,pwmh_period);
	}
}





//non-dma routine for debugging
#if 0
uint8_t LV_VA(float *volt, float *amp)
{
uint32_t r[4];
uint8_t err[4];
uint8_t i;
for(i=0; i<4; ++i) r[i] = uread_injSDADC(SDADC3, LV_channels[i], LV_NREP, err+i);

//volts
if(err[3]) return err[3];
printf("volt readout %d\n",r[3]);
*volt = vrefint2/65536.*LV_factors[3]*r[3]/(float)LV_NREP/LV_gainfactors[3];

err[0]=1; //due to offset in the opamp this range is useless
//amps
float vdrop;
for(i=0; i<3; ++i) //find the lowest range without overflow
	{
	if(!err[i])
		{
		vdrop = vrefint2/65536.*r[i]/(float)LV_NREP/LV_gainfactors[i];
		printf("range %d read %d drop raw %gV\n",i,r[i],vdrop);
		vdrop *= LV_factors[i];
		goto done;
		}
	}
return 3;

done:

//subtract voltage drop on the measuremetn shunt to get true output voltage
*volt -= vdrop;
*amp = vdrop/ R_Isense; 

return 0;
}
#endif


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//pwm routines
// PB5=PWML as tim3ch2 af2
//
void pwmlh_inactivate(void)
{
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_5;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
GPIO_Init(GPIOB, &GPIO_InitStructure);
GPIO_ResetBits(GPIOB, GPIO_Pin_5);

#ifdef PWMH_ON_PB3
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_3;
#else
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6;
#endif
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; //is negated by icl7667
GPIO_Init(GPIOB, &GPIO_InitStructure);
#ifdef PWMH_ON_PB3
GPIO_SetBits(GPIOB, GPIO_Pin_3);
#else
GPIO_SetBits(GPIOB, GPIO_Pin_6);
#endif
}

void pwml_init(float freq, float ratio)
{
//gpio
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_5;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
GPIO_Init(GPIOB, &GPIO_InitStructure);

//timer
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
GPIO_PinAFConfig(GPIOB, GPIO_PinSource5, GPIO_AF_2);

pwml_period = SystemCoreClock / freq;
uint16_t pulse = ratio * pwml_period;

TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
TIM_TimeBaseStructure.TIM_Period = pwml_period;
TIM_TimeBaseStructure.TIM_Prescaler = 0;
TIM_TimeBaseStructure.TIM_ClockDivision = 0;
TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure);

TIM_OCInitTypeDef  TIM_OCInitStructure;
TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
TIM_OCInitStructure.TIM_Pulse = pulse;
TIM_OCInitStructure.TIM_OCMode=TIM_OCMode_PWM1;
TIM_OCInitStructure.TIM_OCPolarity=TIM_OCPolarity_High;
TIM_OC2Init(TIM3, &TIM_OCInitStructure);
//TIM_OC2PreloadConfig(TIM3, TIM_OCPreload_Enable);
//TIM_ARRPreloadConfig(TIM3, ENABLE);
TIM_Cmd(TIM3, ENABLE);
}

// PB6=PWMH as tim_pwmh
void pwmh_init(float freq, float ratio)
{
//gpio
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
#ifdef PWMH_ON_PB3
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_3;
#else
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6;
#endif
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP; //is negated by icl7667
GPIO_Init(GPIOB, &GPIO_InitStructure);

//timer
#ifdef PWMH_ON_PB3
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM13, ENABLE);
GPIO_PinAFConfig(GPIOB, GPIO_PinSource3, GPIO_AF_9);
#else
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);
GPIO_PinAFConfig(GPIOB, GPIO_PinSource6, GPIO_AF_2);
#endif

pwmh_period = SystemCoreClock / freq;
uint16_t pulse = ratio * pwmh_period;

//printf("test %d %d\n",pwmh_period,pulse);

TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
TIM_TimeBaseStructure.TIM_Period = pwmh_period;
TIM_TimeBaseStructure.TIM_Prescaler = 0;
TIM_TimeBaseStructure.TIM_ClockDivision = 0;
TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;

TIM_TimeBaseInit(TIM_PWMH, &TIM_TimeBaseStructure);

TIM_OCInitTypeDef  TIM_OCInitStructure;
TIM_OCInitStructure.TIM_OCMode=TIM_OCMode_PWM1;
TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
TIM_OCInitStructure.TIM_OCPolarity=TIM_OCPolarity_Low; //negated by ICL7667
TIM_OCInitStructure.TIM_Pulse = pulse;
TIM_OC1Init(TIM_PWMH, &TIM_OCInitStructure);
//TIM_OC1PreloadConfig(TIM_PWMH, TIM_OCPreload_Enable); //disables later update of  TIM_PWMH->CCR1
//TIM_ARRPreloadConfig(TIM_PWMH, ENABLE);
TIM_Cmd(TIM_PWMH, ENABLE);
}

//NOTE simple change pulse width: TIM_PWMH->CCR1 = pulse;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//leds - PA8-12
void init_led(void)
{
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
GPIO_Init(GPIOA, &GPIO_InitStructure);
}

//order blue,green,red, redL, yellowR
void led(uint8_t which, uint8_t onoff) //which = 0-4
{
uint16_t pin = 1;
pin <<= 8+which;
if(onoff) GPIO_SetBits(GPIOA,pin); else GPIO_ResetBits(GPIOA,pin);
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//step motor
//PB1 = STEP_EN1
//PB2 = STEP_EN2
//PB9=STEP_1A
//PB10=STEP_1B
//PB14=STEP_2A
//PB15=STEP_2B

#define EN1 GPIO_Pin_1
#define EN2 GPIO_Pin_2
#define IN1 GPIO_Pin_9
#define IN2 GPIO_Pin_10
#define IN3 GPIO_Pin_14
#define IN4 GPIO_Pin_15
#define ALL (EN1|EN2|IN1|IN2|IN3|IN4)


void init_step(void)
{
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_14|GPIO_Pin_15;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
GPIO_Init(GPIOB, &GPIO_InitStructure);
GPIO_ResetBits(GPIOB,GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_14|GPIO_Pin_15);

//initialize timer 19 for autonomous rotation via interrupts
RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM19, ENABLE);
RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM19, ENABLE);
RCC_APB2PeriphResetCmd(RCC_APB2Periph_TIM19, DISABLE);
TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;
TIM_TimeBaseStructInit(&TIM_TimeBaseInitStructure);
TIM_TimeBaseInitStructure.TIM_Prescaler=2;
TIM_TimeBaseInitStructure.TIM_Period = (XTAL*PLLMULT)/2/1000;
TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
TIM_TimeBaseInit(TIM19,&TIM_TimeBaseInitStructure);
TIM_InternalClockConfig(TIM19);
TIM19->CNT=0;
TIM_ITConfig(TIM19, TIM_IT_Update, ENABLE);
TIM_Cmd(TIM19,ENABLE);

NVIC_InitTypeDef NVIC_InitStructure;
NVIC_InitStructure.NVIC_IRQChannel = TIM19_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);

}


void enable_step(uint8_t onoff)
{
if(onoff) GPIO_SetBits(GPIOB,GPIO_Pin_1|GPIO_Pin_2); else GPIO_ResetBits(GPIOB,GPIO_Pin_1|GPIO_Pin_2);
GPIO_ResetBits(GPIOB,IN1|IN2|IN3|IN4);
}

//bipolar step pattern
#define NSTEPS 8
static const uint16_t xstep[NSTEPS]={
/*
IN1|EN1,
IN3|EN2,
IN2|EN1,
IN4|EN2,
*/
IN1|EN1,
IN1|EN1|IN3|EN2,
IN3|EN2,
IN3|EN2|IN2|EN1,
IN2|EN1,
IN2|EN1|IN4|EN2,
IN4|EN2,
IN4|EN2|IN1|EN1,
/*
IN1|EN1|EN2,
IN3|EN1|EN2,
IN2|EN1|EN2,
IN4|EN1|EN2,
*/
};


#if 0
//this is non-interrupt version of the routine
void stepseq0(uint16_t n, uint8_t dir,uint16_t delay, uint8_t cont) __attribute__((optimize("-O1"))); //anything higher has bug in 
void stepseq0(uint16_t n, uint8_t dir,uint16_t delay, uint8_t cont) 
{
static uint8_t t=0;
while(n--)
	{
	uint16_t x = xstep[dir?t:NSTEPS-1-t];
	if(++t==NSTEPS) t=0;
	uint16_t y = ALL^x;
	//printf("test %x %x\n",x,y);//optimizer bug disappears when print is called!!!
	GPIO_ResetBits(GPIOB,y);
	GPIO_SetBits(GPIOB,x);
	delay_ms(delay);
	}
if(!cont) enable_step(0);
}
#endif

static volatile uint16_t nsteps=0;
static volatile uint8_t direction;
static volatile stepdelay;
static volatile steptmp;


void stepseq(uint16_t n, uint8_t dir,uint16_t delay)
{
enable_step(1);
direction=dir;
stepdelay=delay;
steptmp=0;
nsteps=n;
}


static volatile uint32_t milliseconds=0;
void TIM19_IRQHandler(void) __attribute__((optimize("-O1"))); 
void TIM19_IRQHandler(void) //this is called every millisecond to update counter and also controls step motor
{
TIM_ClearITPendingBit(TIM19,TIM_IT_Update);
++milliseconds;

if(nsteps && milliseconds%stepdelay ==0) //make a step
	{
	--nsteps;
	uint16_t x = xstep[direction?steptmp:NSTEPS-1-steptmp];
	if(++steptmp==NSTEPS) steptmp=0;
	uint16_t y = ALL^x;
	GPIO_ResetBits(GPIOB,y);
        GPIO_SetBits(GPIOB,x);
	if(!nsteps)  enable_step(0); //last step was done
	}
}


//initialize parameters for xray mode
static volatile float HV_amps_set;
void init_xray(void)
{
//assure maximum xray lamp ratings
hv_exciter(HV_active=0); //no xray yet
HV_duty=0;
HV_volts_set=XV_volts_max*0.75;
HV_amps_max=XV_amps_max;
HV_amps_set=XV_amps_max*.5;
LV_volts_set = XV_filament_volts_max;
LV_amps_max = 0.1 * XV_filament_amps_max;
LV_active=1; //slowly start filament heating
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

//external relay
void relay(uint8_t onoff)
{
GPIO_InitTypeDef GPIO_InitStructure;
#ifdef RELAY_ON_PB4
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
GPIO_Init(GPIOB, &GPIO_InitStructure);
if(onoff) GPIO_SetBits(GPIOB, GPIO_Pin_4); else GPIO_ResetBits(GPIOB, GPIO_Pin_4);
#else
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_0;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
GPIO_Init(GPIOA, &GPIO_InitStructure);
if(onoff) GPIO_SetBits(GPIOA, GPIO_Pin_0); else GPIO_ResetBits(GPIOA, GPIO_Pin_0);
#endif
}


//ventilator PE12
void ventil(uint8_t onoff)
{
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOE, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_12;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
GPIO_Init(GPIOE, &GPIO_InitStructure);
if(onoff) GPIO_SetBits(GPIOE, GPIO_Pin_12); else GPIO_ResetBits(GPIOE, GPIO_Pin_12);
}

// HV_EXCITER
void hv_exciter(uint8_t onoff)
{
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOE, ENABLE);
GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_13;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
GPIO_Init(GPIOE, &GPIO_InitStructure);
if(onoff) GPIO_SetBits(GPIOE, GPIO_Pin_13); else GPIO_ResetBits(GPIOE, GPIO_Pin_13);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//rotcoder and pushbuttons routines
//
//right:
////I0:01
////I1:00
////I0:10
////I1:11
////
////left:
////I1:10
////I0:00
////I1:01
////I0:11
////


//the mode with changing frequency is dangerous and should be used only for testing while on current-limited lab power supply, otherwise core saturation an subsequent destruction of the power mosfets might occur
//#define LCD_MODE_MAX 3
//two normal working modes
#define LCD_MODE_MAX 3
volatile uint8_t rotcoder_mode=0;
volatile int8_t lcd_mode=0;

static const float HV_step[N_HV]={100.,1.};
static const float HV_max[N_HV]={50000.,1000.};


//initialization values
volatile uint16_t LV_freq=21000.;
volatile uint16_t HV_freq=12000.;


void process_rotation(uint8_t dir)
{
//printf("rotation %d\n",dir);
//if(dir && TIM_PWMH->CCR1< pwml_period-51) TIM_PWMH->CCR1+=50;
//if(dir==0 && TIM_PWMH->CCR1 > 50) TIM_PWMH->CCR1-=50;
//if(dir && TIM3->CCR2< pwml_period-21) TIM3->CCR2+=20;
//if(dir==0 && TIM3->CCR2 > 20) TIM3->CCR2-=20;

switch(lcd_mode) {
    case 2: //no-feedback-mode for experimenting
    switch(rotcoder_mode){
        case 0: //HV freq
		if(dir==0 && HV_freq > 1000) HV_freq -= 100;
		if(dir && HV_freq < 40000)  HV_freq += 100;
		pwmh_init(HV_freq,HV_duty);
                break;
        case 1: //HV duty
		if(dir==0 && HV_duty>0.) HV_duty-= 0.001;
		if(dir && HV_duty < 1.) HV_duty += 0.001;
		if(!HV_active) HV_duty=0;
		if(HV_duty>HV_maxduty) HV_duty=HV_maxduty;
		if(HV_duty<0) HV_duty=0;
		pwmh_init(HV_freq,HV_duty);
                break;
        case 2: //LV freq
		if(dir==0 && LV_freq > 1000) LV_freq -= 100;
                if(dir && LV_freq < 40000)  LV_freq += 100;
		LV_active=1;
		pwml_init(LV_freq,LV_duty);
                break;
        case 3: //LV duty
		if(dir==0 && LV_duty>0.) LV_duty-= 0.001;
                if(dir && LV_duty < 1.) LV_duty += 0.001;
		LV_active=1;
		if(LV_duty>1.) LV_duty=1.;
                if(LV_duty<0.) LV_duty=0.;
		pwml_init(LV_freq,LV_duty);
                break;
        }
        break;

    case 1: //xray mode
    switch(rotcoder_mode){
        case 0:
                if(dir==0 && HV_volts_set>0) HV_volts_set-= 100;
                if(dir && HV_volts_set < XV_volts_max) HV_volts_set+= 100;
                break;
        case 1:
                if(dir==0 && HV_amps_set>0.00001) HV_amps_set *= 1/1.024;
                if(dir) HV_amps_set *= 1.024;
		if(HV_amps_set>XV_amps_max) HV_amps_set=XV_amps_max;
                break;
	}
	break;

    case 0: //normal operation mode
    default:
    switch(rotcoder_mode){
	case 0:
                if(dir==0 && HV_volts_set>0) HV_volts_set-= HV_step[hv_module];
                if(dir && HV_volts_set < HV_max[hv_module]) HV_volts_set+= HV_step[hv_module];
		break;
	case 1:
		if(dir==0 && HV_amps_max>0.00001) HV_amps_max*= 1/1.024;
                if(dir && HV_amps_max < .5) HV_amps_max *= 1.024;
		break;
	case 2:
		if(dir==0 && LV_volts_set>0) LV_volts_set-= 0.1;
		if(dir && LV_volts_set < 35) LV_volts_set+= 0.1;
		if(LV_volts_set<0) LV_volts_set=0;
		LV_active=1;
		break;
	case 3:
		if(dir==0 && LV_amps_max>0.01) LV_amps_max*= 1/1.024;
		if(dir && LV_amps_max < 30) LV_amps_max *= 1.024;
		LV_active=1;
		break;
	}
	break;
    }
}

volatile static int8_t rotcount=0;
void rotcoder(uint8_t interrupt, uint8_t pins)
{
if(interrupt)
        {
        if(pins==0 || pins==3) ++rotcount;
        else --rotcount;
        }
else
        {
        if(pins==0 || pins==3) --rotcount;
        else ++rotcount;
        }
if(rotcount==4) {process_rotation(1); rotcount=0;}
if(rotcount== -4) {process_rotation(0); rotcount=0;}
}

void process_press(uint16_t millisec)
{
if(millisec< 500) rotcoder_mode= (rotcoder_mode+1)%(lcd_mode==1?2:4); //in xray mode only 2 possibilities
}

volatile uint8_t do_lcd_init=0;

void process_buttons(uint8_t which, uint16_t millisec)
{
//printf("button %d pressed for %d\n",which,millisec);
if(which==1) {++lcd_mode; if(lcd_mode>=LCD_MODE_MAX) lcd_mode -= LCD_MODE_MAX;}
else {--lcd_mode; if(lcd_mode<0) lcd_mode += LCD_MODE_MAX;}
rotcoder_mode=0;
do_lcd_init=1;
if(lcd_mode == 2) no_feedback_mode=1; else no_feedback_mode=0;
if(lcd_mode == 1) {hv_exciter(HV_active=0); HV_duty=0; xray_mode = 1; init_xray();} else xray_mode=0; //start with xray off
}


void process_switch(uint8_t position)
{
//printf("switch is now %d\n",position);
switch(position) {
case 0:
	hv_exciter(HV_active=0);
	HV_duty=0;
	HV_remote=0;
	pwmh_init(HV_freq,HV_duty);
	break;
case 1:
	hv_exciter(HV_active=0);
	HV_duty=0;
	HV_remote=1;
	pwmh_init(HV_freq,HV_duty);
	break;
case 2:
	HV_remote=0;
	if(xray_mode) break; //for safety do not allow to locally switch xray on - only remote operation allowed
	hv_exciter(HV_active=1);
	break;
default:
	break;
}
}


void EXTI0_IRQHandler(void)
{
EXTI_ClearITPendingBit(EXTI_Line0);
printf("exti0\n");
}

void EXTI1_IRQHandler(void)
{
EXTI_ClearITPendingBit(EXTI_Line1);
printf("exti1\n");
}

void EXTI2_TS_IRQHandler(void)
{
EXTI_ClearITPendingBit(EXTI_Line2); 
rotcoder(0,(GPIO_ReadInputData(GPIOE)>>2)&3);
randomseed += TIM5->CNT;
}

void EXTI3_IRQHandler(void) 
{
EXTI_ClearITPendingBit(EXTI_Line3);
rotcoder(1,(GPIO_ReadInputData(GPIOE)>>2)&3);
randomseed += TIM5->CNT;
}

volatile uint32_t rotpressed;

void EXTI4_IRQHandler(void) //rotate push
{
EXTI_ClearITPendingBit(EXTI_Line4);
if(GPIO_InputDataBit(GPIOE,GPIO_Pin_4)) process_press((uint32_t)(TIM5->CNT-rotpressed)/(SystemCoreClock/1000));
else rotpressed=TIM5->CNT;
randomseed += TIM5->CNT;
}


volatile uint32_t butpressed[2];

void EXTI9_5_IRQHandler(void) // button left,right, sw left
{
uint8_t which=3;
if(EXTI_GetITStatus(EXTI_Line5)==SET) which=0;
if(EXTI_GetITStatus(EXTI_Line6)==SET) which=1;
if(EXTI_GetITStatus(EXTI_Line9)==SET) which=2;
EXTI_ClearITPendingBit(EXTI_Line5);
EXTI_ClearITPendingBit(EXTI_Line6);
EXTI_ClearITPendingBit(EXTI_Line7);
EXTI_ClearITPendingBit(EXTI_Line8);
EXTI_ClearITPendingBit(EXTI_Line9);
randomseed += TIM5->CNT;
if(which==2)
	{
	process_switch(GPIO_InputDataBit(GPIOF,GPIO_Pin_9)?0:1);
	return;
	}
else
if(GPIO_InputDataBit(GPIOE,which?GPIO_Pin_6:GPIO_Pin_5))
	process_buttons(which,(uint32_t)(TIM5->CNT-butpressed[which])/(SystemCoreClock/1000));
else	butpressed[which]=TIM5->CNT;
}

void EXTI15_10_IRQHandler(void) //switch right
{
EXTI_ClearITPendingBit(EXTI_Line10);
EXTI_ClearITPendingBit(EXTI_Line11);
EXTI_ClearITPendingBit(EXTI_Line12);
EXTI_ClearITPendingBit(EXTI_Line13);
EXTI_ClearITPendingBit(EXTI_Line14);
EXTI_ClearITPendingBit(EXTI_Line15);
process_switch(GPIO_InputDataBit(GPIOF,GPIO_Pin_10)?0:2);
}



void init_rotcoder_buttons(void)
{
//init gpio
GPIO_InitTypeDef GPIO_InitStructure;
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOE, ENABLE);
RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOF, ENABLE);

GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_6;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
GPIO_Init(GPIOE, &GPIO_InitStructure);

GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_10;
GPIO_Init(GPIOF, &GPIO_InitStructure);

delay_ms(10);

//init interrupts
RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);

SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOE,EXTI_PinSource2);
SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOE,EXTI_PinSource3);
SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOE,EXTI_PinSource4);
SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOE,EXTI_PinSource5);
SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOE,EXTI_PinSource6);
SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOF,EXTI_PinSource9);
SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOF,EXTI_PinSource10);

EXTI_InitTypeDef EXTI_InitStructure;
EXTI_InitStructure.EXTI_Line = EXTI_Line2|EXTI_Line3|EXTI_Line4|EXTI_Line5|EXTI_Line6|EXTI_Line9|EXTI_Line10;
EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising_Falling;
EXTI_InitStructure.EXTI_LineCmd = ENABLE;
EXTI_Init(&EXTI_InitStructure);

NVIC_InitTypeDef NVIC_InitStructure;
NVIC_InitStructure.NVIC_IRQChannel = EXTI2_TS_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x0f;
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0F;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0e;
NVIC_InitStructure.NVIC_IRQChannel = EXTI3_IRQn;
NVIC_Init(&NVIC_InitStructure);
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0d;
NVIC_InitStructure.NVIC_IRQChannel = EXTI4_IRQn;
NVIC_Init(&NVIC_InitStructure);
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0c;
NVIC_InitStructure.NVIC_IRQChannel = EXTI15_10_IRQn;
NVIC_Init(&NVIC_InitStructure);
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x0b;
NVIC_InitStructure.NVIC_IRQChannel = EXTI9_5_IRQn;
NVIC_Init(&NVIC_InitStructure);

//init timer 5 for button press
RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM5, ENABLE);
RCC_APB1PeriphResetCmd(RCC_APB1Periph_TIM5, DISABLE);
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM5, ENABLE);
TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;
TIM_TimeBaseStructInit(&TIM_TimeBaseInitStructure);
TIM_TimeBaseInitStructure.TIM_Prescaler=1;
TIM_TimeBaseInit(TIM5,&TIM_TimeBaseInitStructure);
TIM_InternalClockConfig(TIM5);
TIM_Cmd(TIM5,ENABLE);

}







////////////////////////////////////////////////////////////////////////////////////////
//
FILE *us2;
char geigerforward='u';
uint8_t outnet=0;


void process_command(const char *cmd, char *reply)
{
switch(cmd[0]) {	
	case 'e': //test i2c eeprom: read/write a byte
		{
		uint32_t adr,data;
		uint8_t buf;
		switch(cmd[1]){
			case 'r':
				sscanf(cmd+2,"%d",&adr);
				if(mcp24aaReadByte(adr,&buf)) printf("eeprom read failed\n");
				printf("byte read = %02x\n",buf);
				break;
			case 'w':	
				sscanf(cmd+2,"%d %d",&adr,&data);
				buf=data;
				if(mcp24aaWriteByte(adr,buf)) printf("eeprom write failed\n");
				break;
			default:;
		}}
		break;
	case 'C': //read port 1 of i2c expander
		{
		I2C_LowLevel_Init();
                MCP23017_Setdirection(1,0x00); 
                MCP23017_Setpolarity(1,0x00); 
		MCP23017_Setpullup(1,0xff);
		uint8_t r=MCP23017_Read(1);
		printf("PORT1 = %02x\n",r);
		}
		break;
	case 'c': //control camera via i2c expander
		I2C_LowLevel_Init();
		MCP23017_Setdirection(0,0xc0); //focus
                MCP23017_Setpolarity(0,0x00); 
		MCP23017_SetBits(0,0x40); 
		delay_ms(2000);
		if(cmd[1]=='c')
			{
			MCP23017_SetBits(0,0xc0); //trigger
			delay_ms(1000);
			}
		MCP23017_ResetBits(0,0xc0);
		break;
	case 'O': //output direction
		if(cmd[1]=='u') outnet=0;
		if(cmd[1]=='n') outnet=1;
		break;
	case 'R': //relay
		relay(cmd[1]-'0');
		sprintf(reply,"relay=%d\n",cmd[1]-'0');
		break;
	case 'r': //rotate
		{
		int n,dir,delay;
		if(2!=sscanf(cmd+1,"%d %d",&n,&delay)) {sprintf(reply,"bad data after r command\n");break;}
		dir=1;
		if(n<0) {dir=0; n= -n;}
		stepseq(n,dir,delay);
		}
		break;
	case 'G': //forward command to the geiger counter
		fputs(cmd+1,us2);
		break;
	case 'g': //set geiger output destination
		geigerforward=cmd[1];
		break;
	case 'm': //change mode
		lcd_mode = (cmd[1]-'0')%LCD_MODE_MAX;
		if(lcd_mode == 2) no_feedback_mode=1; else no_feedback_mode=0;
		if(lcd_mode == 1) {xray_mode = 1; init_xray();} else xray_mode=0;
		do_lcd_init=1;	
		break;
		
#if 0
	case 'M': //change alternate HV module
		{
		hv_exciter(HV_active=0);
		HV_duty=0;
		HV_volts_set = 0.;
		hv_module = (cmd[1]-'0')%N_HV;
		sprintf(reply,"HV module has been changed to %d and deactivated\n",hv_module);
		}
#endif
	case 'L':
	case 'H': //set H/LV voltage or current or frequency and duty
		{
		float tmp;
		int r=sscanf(cmd+2,"%f",&tmp);
		if(r==1)
			{
			switch(cmd[1]) {
				case 'V':
					if(cmd[0]=='H') HV_volts_set = tmp; else LV_volts_set = tmp;
					sprintf(reply,"%cV Vset = %f\n",cmd[0],tmp);
					break;
				case 'A':
					if(cmd[0]=='H') HV_amps_max = tmp; else LV_amps_max = tmp; 
					sprintf(reply,"%cV Amps max = %f\n",cmd[0],tmp);
					break;
				case 'a':
					if(cmd[0]=='H') 
						{
						HV_amps_set = tmp;  
						sprintf(reply,"%cV Amps set = %f\n",cmd[0],tmp);
						}
					break;
				case 'f':
					if(cmd[0]=='H') HV_freq = tmp; else LV_freq=tmp;
					sprintf(reply,"%cf = %.0fHz\n",cmd[0],tmp);
					if(cmd[0]=='H') pwmh_init(HV_freq,HV_duty); else pwml_init(LV_freq,LV_duty);
					break;
				case 'd':
					if(tmp<0.) tmp=0.;
					if(tmp>1.) tmp=1.;
					if(cmd[0]=='H') HV_duty = tmp; else LV_duty=tmp;
                                        sprintf(reply,"%cduty = %.3f\n",cmd[0],tmp);
                                        if(cmd[0]=='H') pwmh_init(HV_freq,HV_duty); else pwml_init(LV_freq,LV_duty);
					break;
				default: sprintf(reply,"bad format of H or L command\n");
				}
			}
		else sprintf(reply,"bad format of H or L command\n");
		}
		break;
	case 'h': //toggle HV on if allowed by local switch
		if(HV_remote)
			{
			if(cmd[1]=='1')
				{
				hv_exciter(HV_active=1);	
				sprintf(reply,"HV is now ON!!!\n");
				}
			else
				{
				hv_exciter(HV_active=0);
				HV_duty=0;
				sprintf(reply,"HV is now OFF\n");
				}
			}
		else
			{
			sprintf(reply,"HV switch prevents remote control\n");
			}
		break;
	case 'l': //toggle LV
		if(cmd[1]=='1')
                                {
                                LV_active=1;
                                sprintf(reply,"LV is now ON\n");
                                }
                        else
                                {
                                LV_active=0;
                                sprintf(reply,"LV is now OFF\n");
                                }
		break;
	case '\n':
	case '\r':
	case ' ':
	case 0:
		reply[0]='\n'; reply[1]=0;
		break;
	default:
		sprintf(reply,"highvolt: unknown command %s\n",cmd);
		break;
}
}




int main(void)
{
//PWML AND PWMH tie to zero before init will be called
pwmlh_inactivate();

watchdog_init(10000);

//external relay
relay(0);

//safety HV switch off
hv_exciter(0);

//cooling fan
ventil(1); 

FILE *us1=fopen("usart 1 115200 0","w+"); setlinebuf(us1);
us2=fopen("usart 2 115200 0","w+"); setlinebuf(us2);
FILE *us3=fopen("usart 3 115200 1","w+"); setlinebuf(us3);
stdout=stderr=us3;
fprintf(us3,"Reset\n");


lcd_init(); lcd_light(1);
lcd_print("Reset");

I2C_LowLevel_Init();

init_rotcoder_buttons();

//initial state of the switch
delay_ms(50);
process_switch(GPIO_InputDataBit(GPIOF,GPIO_Pin_9)?0:1);
process_switch(GPIO_InputDataBit(GPIOF,GPIO_Pin_10)?0:2);

init_led();
led(0,1);led(1,1);led(2,1);


init_step();

//reference voltage common to all SDADCs
 /* NOTE!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 * Select External reference: The reference voltage selection is available
     only in SDADC1 and therefore to select the VREF for SDADC2/SDADC3, SDADC1
     clock must be already enabled */

RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR,ENABLE);
PWR_SDADCAnalogCmd(PWR_SDADCAnalog_1, ENABLE);
RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);
RCC_APB2PeriphClockCmd(RCC_APB2Periph_SDADC1, ENABLE);
RCC_APB2PeriphClockCmd(RCC_APB2Periph_SDADC2, ENABLE);
RCC_APB2PeriphClockCmd(RCC_APB2Periph_SDADC3, ENABLE);
SDADC_VREFSelect(SDADC_VREF_VREFINT2);
 

uint8_t r;

r=init_SDADC3(0,LV_sdadc_gains,LV_sdadc_configs,LV_channels,LV_data,LV_NREP,LV_NCHAN);
printf("first init_SDADC3 returned %d\n",r);
delay_ms(10);
if(r) { printf("needs hw reset %d\n",r); while(1); }

	{
	uint32_t r = uread_regSDADC(SDADC3,2048);
	float x = VREFINT2*2*r/2048./65536.;
	printf("V2.5 measured as %f should be %f correction %g\n",x,VREF25,VREF25/x);
	vrefint2 = VREFINT2*VREF25/x;
	}

r=init_SDADC3(1,LV_sdadc_gains,LV_sdadc_configs,LV_channels,LV_data,LV_NREP,LV_NCHAN);
printf("second init_SDADC3 returned %d\n",r);
delay_ms(10);
if(r) { printf("needs hw reset %d\n",r); while(1); }

r=init_SDADC2(1,HV_sdadc_gains,HV_sdadc_configs,HV_channels,HV_data,HV_NREP,HV_NCHAN);
printf("init_SDADC2 returned %d\n",r);
delay_ms(10);
if(r) { printf("needs hw reset %d\n",r); while(1); }


//some reasonable initial values
LV_volts_set = 5.;
LV_amps_max = 3.;

HV_volts_set = 10000.;
HV_amps_max = .004;


pwml_init(LV_freq,LV_duty);
printf("LV Init done\n");
pwmh_init(HV_freq,HV_duty);
printf("HV Init done\n");

init_lan(0);
printf("LAN Init done\n");

led(2,0);
uint32_t pass=0;
rotcoder_mode=0;
while(1)
{
if((pass&0xff)==0xff || do_lcd_init) {do_lcd_init=0; lcd_init(); lcd_light(1);} //refresh display

//check input from usart1 ... not used presently
if(inuart1line) //select not implemented yet
	{
	char line[256];
	char *p=fgets(line,256,us1);
	if(p) printf("Unexpected input from USART1: %s\n",line);
	}


//check input from usart2 ... geiger
if(inuart2line) //select not implemented yet
        {
	char line[256];
	sprintf(line,"GEIGER: %s",inuart2);
	if(geigerforward=='s') fputs(line,us3);
	if(geigerforward=='n' || geigerforward=='u') write_udp2(line);
	inuart2line=inuart2len=0;
        }

//check input from usart3 ... debug+comm
if(inuart3line) //select not implemented yet
        {
        char line[256];
        char *p=fgets(line,256,us3);
        if(p) 
		{
		char reply[1024];
		process_command(line,reply);
		fputs(reply,us3);
		}
        }


char *udp = read_udp(N_WHITE_IP,ip_whitelist);
if(udp) 
	{
	//printf("UDP IN\n");
	char reply[1024];
        process_command(udp,reply);
	write_udp2(reply);
	}

#define PRINTMODULO 127

if(xray_mode) //coarse control loop in xray mode
	{
	if(HV_active)
		{
		//keep HV voltage fixed, keep LV voltage sufficient (current limited)
		LV_volts_set = XV_filament_volts_max;
		//regulate HV_amps by changing the filament current LV_amps_max
		if(HV_amps < HV_amps_set*0.98)
			{
			float tmp = LV_amps_max*1.01;
			LV_amps_max= tmp<=XV_filament_amps_max? tmp : XV_filament_amps_max;
			}
		if(HV_amps > HV_amps_set*1.02)
			{
			if(LV_amps_max> 0.1 * XV_filament_amps_max) LV_amps_max /=1.01;
			}
		}
	else
		{
		LV_volts_set = 0.1 * XV_filament_volts_max;
		LV_amps_max = 0.1 * XV_filament_amps_max;
		}
	}

//update lcd display
switch(lcd_mode) {
	case 2: //no-feedback-experimentation mode
		{
		char c[23];
		sprintf(c,"%cHV=%4.1fkV F=%5dHz",rotcoder_mode==0?'>':' ',HV_volts/1000.,HV_freq);
                lcd_cursor(0,0); lcd_print(c);
                strcat(c," ");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

                sprintf(c,"%cHA=%5.3fmA dut %4.3f",rotcoder_mode==1?'>':' ',HV_amps*1000.,HV_duty);
                lcd_cursor(1,0); lcd_print(c);
                strcat(c," ");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

                sprintf(c,"%cLV=%5.1fV F=%5dHz",rotcoder_mode==2?'>':' ',LV_volts,LV_freq);
                lcd_cursor(2,0); lcd_print(c);
                strcat(c," ");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

                sprintf(c,"%cLA=%5.2fA dut %4.3f",rotcoder_mode==3?'>':' ',LV_amps,LV_duty);
                lcd_cursor(3,0); lcd_print(c);
                strcat(c,"\n");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}
		}
		break;
	case 1: //xray mode
		{
		char c[23];
		if(hv_module!=0) {hv_exciter(HV_active=0); HV_duty=0;  sprintf(c,"hv_module must be 0"); lcd_cursor(0,0); lcd_print(c); break;}

		sprintf(c,"%cHV=%4.1fkV %3s %4.1f",rotcoder_mode==0?'>':' ',HV_volts/1000.,(HV_active?"set":"off"),HV_volts_set/1000.);
                lcd_cursor(0,0); lcd_print(c);
                strcat(c," ");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		sprintf(c,"%cHA=%5.3fmA set %4.2f",rotcoder_mode==1?'>':' ',HV_amps*1000.,HV_amps_set*1000.);
		lcd_cursor(1,0); lcd_print(c);
                strcat(c," ");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		sprintf(c," LV=%5.1fV LA=%5.2fA",LV_volts,LV_amps);
                lcd_cursor(2,0); lcd_print(c);
                strcat(c," ");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		sprintf(c,"XRAY %s\n",HV_active?"ON":"OFF");
                lcd_cursor(3,0); lcd_print(c);
                strcat(c,"\n");
                if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		}
		break;
	case 0: //normal power supply operation mode
	default:
		{
		char c[23];
		if(hv_module==0) sprintf(c,"%cHV=%4.1fkV %3s %4.1f",rotcoder_mode==0?'>':' ',HV_volts/1000.,(HV_active?"set":"off"),HV_volts_set/1000.);
		else	sprintf(c,"%cMV=%4.0fV %3s %4.0f",rotcoder_mode==0?'>':' ',HV_volts,(HV_active?"set":"off"),HV_volts_set);
		lcd_cursor(0,0); lcd_print(c);
		strcat(c," ");
		if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		if(hv_module==0)  sprintf(c,"%cHA=%5.3fmA max %4.2f",rotcoder_mode==1?'>':' ',HV_amps*1000.,HV_amps_max*1000.);
		else  sprintf(c,"%cMA=%5.1fmA max %5.1f",rotcoder_mode==1?'>':' ',HV_amps*1000.,HV_amps_max*1000.);
		lcd_cursor(1,0); lcd_print(c);
		strcat(c," ");
		if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		sprintf(c,"%cLV=%5.1fV %3s %4.1f",rotcoder_mode==2?'>':' ',LV_volts,(LV_active?"set":"off"),LV_volts_set);
		lcd_cursor(2,0); lcd_print(c);
		strcat(c," ");
		if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}

		sprintf(c,"%cLA=%5.2fA max %5.2f",rotcoder_mode==3?'>':' ',LV_amps,LV_amps_max);
		lcd_cursor(3,0); lcd_print(c);
		strcat(c,"\n");
		if((pass&PRINTMODULO)==0) {if(outnet) write_udp2(c); else fputs(c,stdout);}
		}
		break;
}//switch
//printf("main end %d\n",pass);
//test_lan(pass);
++pass;
}//while
}//main

