/*
 * I have adapted I2C routines which were posted in some internet forum and added the two SMBUS... ones, so this is public domain...
 * NOTE!!! the I2C hardware implementation is COMPLETELY DIFFERENT in STM32F4 and STM32F37 and I had to rewrite this code completely - WHAT THE FUCK IS THE REASON FOR CHANGING IT BETWEEN DIFFERENT PROCESSOR SERIES?!!!
 * Jiri Pittner <jiri@pittnerovi.com>
 */



#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "i2c1.h"

//i2c
//


//GPIO and I2C Peripheral (I2C3 Configuration)

#ifdef I2C1_ON_B78
#define I2Cx                      I2C1  //Selected I2C peripheral
#define RCC_APB1Periph_I2Cx       RCC_APB1Periph_I2C1 //Bus where the peripheral is connected
#define RCC_AHBPeriph_GPIO_SCL   RCC_AHBPeriph_GPIOB  //Bus for GPIO Port of SCL
#define RCC_AHBPeriph_GPIO_SDA   RCC_AHBPeriph_GPIOB  //Bus for GPIO Port of SDA
#define GPIO_AF_I2Cx              GPIO_AF_4    //Alternate function for GPIO pins
#define GPIO_SCL                  GPIOB
#define GPIO_SDA                  GPIOB
#define GPIO_Pin_SCL              GPIO_Pin_8
#define GPIO_Pin_SDA              GPIO_Pin_7
#define GPIO_PinSource_SCL        GPIO_PinSource8
#define GPIO_PinSource_SDA        GPIO_PinSource7
#endif

#ifdef I2C1_ON_B67
#define I2Cx                      I2C1  //Selected I2C peripheral
#define RCC_APB1Periph_I2Cx       RCC_APB1Periph_I2C1 //Bus where the peripheral is connected
#define RCC_AHBPeriph_GPIO_SCL   RCC_AHBPeriph_GPIOB  //Bus for GPIO Port of SCL
#define RCC_AHBPeriph_GPIO_SDA   RCC_AHBPeriph_GPIOB  //Bus for GPIO Port of SDA
#define GPIO_AF_I2Cx              GPIO_AF_4    //Alternate function for GPIO pins
#define GPIO_SCL                  GPIOB
#define GPIO_SDA                  GPIOB
#define GPIO_Pin_SCL              GPIO_Pin_6
#define GPIO_Pin_SDA              GPIO_Pin_7
#define GPIO_PinSource_SCL        GPIO_PinSource6
#define GPIO_PinSource_SDA        GPIO_PinSource7
#endif







//Internal functions
static uint32_t I2C_Addr(uint8_t DevAddr, uint8_t dir, uint8_t cnt, uint8_t autostop);
static uint32_t I2C_Write(uint8_t byte);
static uint32_t I2C_Read(uint8_t *pBuf);
static uint32_t CheckNACK(void);


static uint32_t WaitISRFlagsSet (uint32_t Flags);
static uint32_t WaitLineIdle(void);


void I2C_LowLevel_Init(void) {

I2C_DeInit(I2Cx);

  GPIO_InitTypeDef  GPIO_InitStructure;
  I2C_InitTypeDef   I2C_InitStructure;
  
  //Enable the i2c
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2Cx, ENABLE);
  //RCC_I2CCLKConfig(RCC_I2C1CLK_SYSCLK);
  RCC_I2CCLKConfig(RCC_I2C1CLK_HSI);
  //Reset the Peripheral
  RCC_APB1PeriphResetCmd(RCC_APB1Periph_I2Cx, ENABLE);
  RCC_APB1PeriphResetCmd(RCC_APB1Periph_I2Cx, DISABLE);
  
  //Enable the GPIOs for the SCL/SDA Pins
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIO_SCL | RCC_AHBPeriph_GPIO_SDA, ENABLE);
  
  //Configure and initialize the GPIOs
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_SCL;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_OD; // open drain
  GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL; 
  GPIO_Init(GPIO_SCL, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_SDA;
  GPIO_Init(GPIO_SDA, &GPIO_InitStructure);
  
  //Connect GPIO pins to peripheral
  GPIO_PinAFConfig(GPIO_SCL, GPIO_PinSource_SCL, GPIO_AF_I2Cx);
  GPIO_PinAFConfig(GPIO_SDA, GPIO_PinSource_SDA, GPIO_AF_I2Cx);
  
  //Configure and Initialize the I2C
  I2C_StructInit(&I2C_InitStructure);
  I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
  I2C_InitStructure.I2C_OwnAddress1 = 0x00; //We are the master. We don't need this
  I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
  I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
//I2C_InitStructure.I2C_Timing =  0x10420f13; //100khz from 8MHz hsi clock, bit structure cf. datasheet I2Cx_TIMINGR - times of low, high and edges and prescaler
I2C_InitStructure.I2C_Timing =  0x00310309; //400khz from 8MHz hsi clock, bit structure cf. datasheet I2Cx_TIMINGR - times of low, high and edges and prescaler

  
  //Initialize the Peripheral
  I2C_Init(I2Cx, &I2C_InitStructure);

I2C_StretchClockCmd(I2Cx,ENABLE);
  I2Cx->CR2 |= I2C_CR2_AUTOEND;

  // I2C Peripheral Enable
  I2C_Cmd(I2Cx, ENABLE);
  
  return; 
}


void I2C_LowLevel_DeInit(void) {
  GPIO_InitTypeDef  GPIO_InitStructure; 
  //I2C Peripheral Disable
  I2C_Cmd(I2Cx, DISABLE);
 
  //I2C DeInit (Disables clock)
  I2C_DeInit(I2Cx);
  //RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2Cx, DISABLE);
    
  //GPIO configuration
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_SCL;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
  GPIO_Init(GPIO_SCL, &GPIO_InitStructure);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_SDA;
  GPIO_Init(GPIO_SDA, &GPIO_InitStructure);
  
  return;
}

uint32_t I2C_RdBuf(uint8_t DevAddr, uint8_t *buf, uint32_t cnt) {
  
//if(WaitISRFlagsSet(I2C_ISR_TC)) return 1;
  
  //Send I2C Device Address and clear ADDR
 I2C_TransferHandling(I2Cx, DevAddr<<1, cnt, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);
 //I2C_TransferHandling(I2Cx, DevAddr<<1, cnt, I2C_AutoEnd_Mode, I2C_No_StartStop);

  
  while ((cnt--)>0) {
    if(I2C_Read(buf++)) return 1;
  }

  
  //Make Sure Stop bit is cleared and Line is now Iddle
  return WaitLineIdle();
    
}



uint32_t I2C_RdData(uint8_t DevAddr, uint32_t RegAddr,uint8_t RegAddrsize, uint8_t *buf, uint32_t cnt) {
  //Reads "cnt" number of data starting from RegAddr
  
  if(I2C_Addr(DevAddr, I2C_Direction_Transmitter,RegAddrsize,0)) return 1;

//select register
  if(RegAddrsize>3) { I2Cx->TXDR = (RegAddr>>24)&0xff; if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1; }
  if(RegAddrsize>2) { I2Cx->TXDR = (RegAddr>>16)&0xff; if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1; }
  if(RegAddrsize>1) { I2Cx->TXDR = (RegAddr>>8)&0xff; if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1; }
  I2Cx->TXDR = RegAddr&0xff; 
  if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1;

  
  //Start Reading - itself generates restart and sends address
  return I2C_RdBuf(DevAddr, buf, cnt);
  
}


uint32_t I2C_WrData(uint8_t DevAddr, uint16_t RegAddr,uint8_t RegAddrsize, uint8_t *buf, uint32_t cnt){
  
  
  //Send I2C device Address and clear ADDR
  if(I2C_Addr(DevAddr, I2C_Direction_Transmitter,cnt+RegAddrsize,1)) return 1;

//select register
  if(RegAddrsize>1) {I2Cx->TXDR = RegAddr>>8; if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1;}
  I2Cx->TXDR = RegAddr&0xff; if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1;

  
while(cnt--)
  {
  //Send Data
  I2Cx->TXDR = *buf++;
  if(WaitISRFlagsSet(I2C_ISR_TXE)) return 1;  //wait till the data is actually written.
}
  
  
  //Wait to be sure that line is iddle
  return WaitLineIdle();
  
}



uint32_t I2C_WrBuf(uint8_t DevAddr, uint8_t *buf, uint32_t cnt) {

  
  
  //Send I2C device Address
  if(I2C_Addr(DevAddr, I2C_Direction_Transmitter,cnt,1)) return 1;

  
  //Start Writing Data
  while (cnt--) {
    if(I2C_Write(*buf++)) return 1;
  }
  
  //Wait for the data on the shift register to be transmitted completely
  WaitISRFlagsSet(I2C_ISR_TXE);
  //Here TXE=TXE=1. Therefore the clock stretches again.
  
  
  //Wait to be sure that line is idle
  return WaitLineIdle();
  
}

uint32_t I2C_Wr_byte(uint8_t DevAddr, uint8_t reg, uint8_t byte) 
{
uint8_t msg[2];
msg[0]=reg;
msg[1]=byte;
return I2C_WrBuf(DevAddr,msg,2);
}

uint32_t I2C_Wr_short(uint8_t DevAddr, uint8_t reg, uint16_t sh)              
{
uint8_t msg[3];
msg[0]=reg;
msg[1]=sh&0xff;
msg[2]=sh>>8;
return I2C_WrBuf(DevAddr,msg,3);
}


///////////////PRIVATE FUNCTIONS/////////////////////
static uint32_t I2C_Read(uint8_t *pBuf) {
    uint32_t err;

    //Wait till new data is ready to be read
    err=WaitISRFlagsSet(I2C_ISR_RXNE);
        
    if (!err) {
      *pBuf = I2Cx->RXDR;   
      return 0;
    }
    else {return err;}
    
    
}


static uint32_t I2C_Write(uint8_t byte){
  
  //Write the byte to the DR
  I2Cx->TXDR = byte;
  
//wait until finished
 uint32_t r=  WaitISRFlagsSet(I2C_ISR_TXE);
 uint32_t s= CheckNACK();
 return r|s; 
   
}


//generate start condition and setup transfer length and autostop; address is transmitted not as data but via SADD in CR2
//note that NACK is generated/checked by hardware, if slave not present it will timeout on TXE of next byte
//
static uint32_t I2C_Addr(uint8_t DevAddr, uint8_t dir, uint8_t cnt, uint8_t autoend) {
uint32_t tmpreg;
 tmpreg = I2Cx->CR2;
  
tmpreg &= (uint32_t)~((uint32_t)(I2C_CR2_SADD | I2C_CR2_NBYTES | I2C_CR2_RELOAD | I2C_CR2_AUTOEND | I2C_CR2_RD_WRN | I2C_CR2_START | I2C_CR2_STOP));

  /* update tmpreg */
  tmpreg |= (uint32_t)(((uint32_t)((DevAddr << 1) | dir) & I2C_CR2_SADD) |(autoend?I2C_CR2_AUTOEND:0)| (((uint32_t)cnt << 16 ) & I2C_CR2_NBYTES) | \
            (uint32_t)(dir==I2C_Direction_Receiver?I2C_CR2_RD_WRN:0) | (uint32_t)I2C_CR2_START);

  /* update CR2 register */
  I2Cx->CR2 = tmpreg;

  //Wait till ADDR is transmitted
   uint32_t s= CheckNACK();
  return s;
  
}





static uint32_t CheckNACK(void)
{
if((I2Cx->ISR) & I2C_ISR_NACKF == 0)
	{
	printf("I2C missing NACK\n");
	return 1;
	}
return 0;
}

static uint32_t WaitISRFlagsSet (uint32_t Flags) {
  //Wait till the specified ISR Bits are set
  //More than 1 Flag can be "or"ed. This routine reads only ISR.
  uint32_t TimeOut = HSI_VALUE>>10;

  
  while(((I2Cx->ISR) & Flags) != Flags) {
    if (!(TimeOut--)) {
      printf("I2C Timeout 1\n");
      return 1;
    }
  } 
  return 0;
}


static uint32_t WaitLineIdle(void) {
  //Wait till the Line becomes idle.
  
  uint32_t TimeOut = HSI_VALUE>>10;
  //Check to see if the Line is busy
  //This bit is set automatically when a start condition is broadcasted on the line (even from another master)
  //and is reset when stop condition is detected.
  while((I2Cx->ISR) & (I2C_ISR_BUSY)) {
    if (!(TimeOut--)) {
	 printf("I2C Timeout 2\n");
      return 1;
    }
  }
  
  
  return 0;
}





//end i2c
//


//NOTE: the following SMBUS routines were not tested on the stm32f37 architecture


uint16_t SMBUS_read_word(uint8_t sa, uint8_t cmd)
{
I2C_CalculatePEC(I2Cx,ENABLE);
I2C_Addr(sa, I2C_Direction_Transmitter,1,0);
I2C_Write(cmd);
WaitISRFlagsSet(I2C_ISR_TXE);
I2C_Addr(sa, I2C_Direction_Receiver,2,1);
I2C_TransferHandling(I2Cx,sa<<1, 3, I2C_SoftEnd_Mode, I2C_Generate_Start_Read);
I2C_TransferHandling(I2Cx, sa<<1, 3, I2C_AutoEnd_Mode, I2C_No_StartStop);
uint8_t l,h,pec0;
I2C_Read(&l);
I2C_Read(&h);
uint8_t pec = I2C_GetPEC(I2Cx);
I2C_Read(&pec0);
I2C_CalculatePEC(I2Cx,DISABLE);
//stop
I2Cx->CR2 |= I2C_CR2_STOP;
WaitLineIdle();
//if(pec!=pec0) print(USART2,"PEC does not match\n");
return l|((uint16_t)h<<8);
}


void SMBUS_write_word(uint8_t sa, uint8_t cmd, uint16_t w)
{
I2C_CalculatePEC(I2Cx,ENABLE);
I2C_Addr(sa, I2C_Direction_Transmitter,3,1);
I2C_Write(cmd);
I2C_Write(w&0xff);
I2C_Write(w>>8);
I2Cx->CR1 |= I2C_CR1_PECEN;
I2C_CalculatePEC(I2Cx,DISABLE);
//stop
I2Cx->CR2 |= I2C_CR2_STOP;
WaitLineIdle();
}

//end i2c

