#ifndef i2c2_h_included
#define i2c2_h_included

#include "stm32f37x.h"
#include "stm32f37x_rcc.h"
#include "stm32f37x_gpio.h"
#include "stm32f37x_i2c.h"
#include "stm32f37x_exti.h"
#include "stm32f37x_syscfg.h"
#include "stm32f37x_misc.h"


#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern void I2C2_LowLevel_Init(void);
extern void I2C2_LowLevel_DeInit(void);
extern uint32_t I2C2_RdBuf (uint8_t DevAddr, uint8_t *buf, uint32_t cnt);
extern uint32_t I2C2_RdData(uint8_t DevAddr, uint32_t RegAddr,uint8_t RegAddrsize, uint8_t *buf, uint32_t cnt); //Reads "cnt" number of data starting from RegAddr
extern uint32_t I2C2_WrData(uint8_t DevAddr, uint16_t RegAddr,uint8_t RegAddrsize, uint8_t *buf,  uint32_t cnt); //Write  "cnt" number of data 
extern uint32_t I2C2_WrBuf(uint8_t DevAddr, uint8_t *buf, uint32_t cnt);
extern uint16_t SMBUS2_read_word(uint8_t sa, uint8_t cmd);
extern void SMBUS2_write_word(uint8_t sa, uint8_t cmd, uint16_t w);
extern uint32_t I2C2_Wr_byte(uint8_t DevAddr, uint8_t reg, uint8_t byte);
extern uint32_t I2C2_Wr_short(uint8_t DevAddr, uint8_t reg, uint16_t sh);


#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
