#ifndef _lan_h
#define _lan_h

#include "watchdog.h"

#include "etherShield/enc28j60.h"
#include "etherShield/ip_arp_udp_tcp.h"
#include "etherShield/ip_config.h"
#include "etherShield/websrv_help_functions.h"
#include "etherShield/net.h"
#include "etherShield/dhcp.h"
#include "etherShield/dnslkup.h"

#define INUDPMAX 128
extern volatile uint8_t inudplen;
extern volatile uint8_t inudpline;
extern volatile char inudp[];


#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern uint8_t lan_buf[];
extern uint8_t mymac[6]; //set some arbitrary one for DHCP
extern uint8_t dstmac[6];
extern uint8_t myip[4]; //use DHCP
extern uint8_t mygwip[4];
extern uint8_t dnsip2[4];
extern uint8_t dhcpsrvip[4];
extern uint8_t mynetmask[4];
extern uint8_t destip[4];
extern short dst_port; //answer to this port number regardless from which port it came from
extern short src_port; //our from port


extern uint8_t init_lan(uint8_t newdhcp);
extern uint8_t smtp_session(uint8_t *destip_in, char *from, char *to, char *text);
extern void ping_send(uint8_t *dest);
extern void udp_send(uint8_t *dest,uint16_t dst_port,uint16_t src_port,uint8_t *msg, uint16_t len);
extern uint8_t dns_session(char *domain, uint8_t *mailserver, uint8_t mx);
extern uint8_t dns_smtp_session(char *from, char *to, char *text);
extern void write_udp(uint8_t *msg, uint8_t len);
extern void write_udp2(char *p);
extern char *read_udp(uint8_t n_white_ip, uint8_t ip_whitelist[][4]);


#if defined(__cplusplus) || defined(c_plusplus)
}
#endif


#endif
