#ifndef _MAGNETOMETER
#define _MAGNETOMETER
#include "vecmat3.h"
#include "simple.h"
#include "avi_calibration.h"

using namespace LA_Vecmat3;
using namespace LA_Simple;

extern Vec3<float> magnetic_offsets;
extern Vec3<float> magnetic_scales;

extern simple_linfit<float,FITVARS> magnetic_fit;


extern void init_magnetic_calibration(void); //init fit
extern void accumulate_magnetic_calibration(const Vec3<float> &m, const int periodic_update, int eeprom_ok,const float preserve); //accumulate data for the fit
extern void fit_magnetic_calibration(int eeprom_ok,float preserve); //and store to eeprom
extern void reset_magnetic_calibration(int eeprom_ok); //clear to no correction
extern Vec3<float> magnetometer_corrected(const Vec3<float> &mraw, bool zero_z=false); //apply correction

#endif
