//simple wrapper to handle the eeprom i/o using general I2C routines
//(c) Jiri Pittner 2015

#include "i2c1.h"
#include "mcp24aa.h"


mcp24aaError_e mcp24aaInit()
{
  I2C_LowLevel_Init();
  return MCP24AA_ERROR_OK;
}

mcp24aaError_e mcp24aaReadBuffer (uint16_t address, void *buffer, uint32_t bufferLength)
{

  if (address >= MCP24AA_MAXADDR)
  {
    return MCP24AA_ERROR_ADDRERR;
  }

  if (bufferLength > 8)
  {
    return MCP24AA_ERROR_BUFFEROVERFLOW;
  }

  I2C_RdData(MCP24AA_ADDR,address,EEPROM_ADDR_SIZE,buffer,bufferLength);

  return MCP24AA_ERROR_OK;
}

mcp24aaError_e mcp24aaWriteBuffer (uint16_t address, void *buffer, uint32_t bufferLength)
{

  if (address >= MCP24AA_MAXADDR)
  {
    return MCP24AA_ERROR_ADDRERR;
  }

  if (bufferLength > 8)
  {
    return MCP24AA_ERROR_BUFFEROVERFLOW;
  }

I2C_WrData(MCP24AA_ADDR,address,EEPROM_ADDR_SIZE,buffer,bufferLength);

  return MCP24AA_ERROR_OK;
}


mcp24aaError_e mcp24aaReadByte (uint16_t address, uint8_t *buffer)
{

  return mcp24aaReadBuffer(address, buffer, 1);
}

mcp24aaError_e mcp24aaWriteByte (uint16_t address, uint8_t value)
{

  uint8_t wBuffer[1];

  // Write byte to EEPROM at specified address
  wBuffer[0] = value;
  return mcp24aaWriteBuffer(address, wBuffer, 1);
}

