#ifndef _PRESSURE_SENSORS_H
#define _PRESSURE_SENSORS_H

#include <stdio.h>
#include <stdint.h>

#include "stm32f37x_gpio.h"
#include "stm32f37x_rcc.h"
#include "stm32f37x_pwr.h"
#include "stm32f37x_tim.h"
#include "stm32f37x_exti.h"
#include "stm32f37x_dma.h"
#include "stm32f37x_sdadc.h"
#include "stm32f37x_i2c.h"
#include "stm32f37x_misc.h"
#include "stm32f37x_syscfg.h"

#include "i2c1.h"
#include "i2c2.h"
#include "delay.h"


#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

#define SDADC2_NCHAN 4


extern uint8_t init_pressure(void);
extern void read_pressures(float *p_static, float *p1, float *p2);
extern void process_pressures(float p_static, float p1, float p2, float qnh, float temp, float rel_humidity, float *altitude, float *ias, float *tas, float *aoa, float *density_altitude);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
