#ifndef _sdcard_incl
#define _sdcard_incl

#include <stdint.h>
#include <string.h>

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif



#define SD_BLOCKBITS 9
#define SD_BLOCKSIZE (1<<SD_BLOCKBITS)
#define SD_EXTRABUF 32
#define SD_BUFSIZE (SD_BLOCKSIZE+SD_EXTRABUF)

#ifdef AVR_SOURCE
#define little_endian
#endif
#ifdef ARM_SOURCE37
#define little_endian
#endif


//macros for sector addressing
#define SD_readblock(sector,buf) SD_readblock_a((sector)<<SD_BLOCKBITS,buf)
#define SD_writeblock(sector,buf) SD_writeblock_a((sector)<<SD_BLOCKBITS,buf)


extern uint8_t SDCommand(uint8_t cmd, uint32_t *adr, uint8_t crc);
extern int SD_Init(void);
extern int SDHC_Init(void);
extern uint8_t SD_writeblock_a(uint32_t addr, uint8_t *ptr);
extern uint8_t SD_readblock_a(uint32_t addr, uint8_t *buf);
extern uint8_t SD_error;

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif


#endif
