/*
 *  
 *        Copyright (C) 2022 Jiri Pittner <jiri@pittnerovi.com>
 *
 *         This program is free software: you can redistribute it and/or modify
 *         it under the terms of the GNU General Public License as published by
 *         the Free Software Foundation, either version 3 of the License, or
 *         (at your option) any later version.
 *       
 *          This program is distributed in the hope that it will be useful,
 *          but WITHOUT ANY WARRANTY; without even the implied warranty of
 *          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *          GNU General Public License for more details.
 *          You should have received a copy of the GNU General Public License
 *          along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *          
 *        
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "usart123.h"
#include "delay.h"
#include "stm32f37x_gpio.h"
#include "stm32f37x_rcc.h" 
#include "stm32f37x_pwr.h"
#include "stm32f37x_tim.h"
#include "stm32f37x_exti.h"
#include "stm32f37x_misc.h"
#include "stm32f37x_syscfg.h"

#include "watchdog.h"

void watchdog_init(uint32_t ms)
{
IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
IWDG_SetPrescaler(IWDG_Prescaler_256);
IWDG_SetReload((ms*400000ULL)/256/1000);
IWDG_ReloadCounter();
delay_ms(1);
//@@@why this hangs?
//while(IWDG_GetFlagStatus(IWDG_FLAG_PVU)==SET || IWDG_GetFlagStatus(IWDG_FLAG_RVU)==SET);
IWDG_Enable();
}

void watchdog(void)
{
IWDG_ReloadCounter();
}

void softreset(void)
{
 __ASM volatile ("dsb 0xF":::"memory");
  SCB->AIRCR  = (uint32_t)((0x5FAUL << SCB_AIRCR_VECTKEY_Pos)    |
                           (SCB->AIRCR & SCB_AIRCR_PRIGROUP_Msk) |
                            SCB_AIRCR_SYSRESETREQ_Msk    );  
 __ASM volatile ("dsb 0xF":::"memory");
while(1);
}
